#define __KEYBIOS_H__
#include "fxlib.h"


#define KEY_CHAR_0 OS2(0x30,71)
#define KEY_CHAR_1 OS2(0x31,72)
#define KEY_CHAR_2 OS2(0x32,62)
#define KEY_CHAR_3 OS2(0x33,52)
#define KEY_CHAR_4 OS2(0x34,73)
#define KEY_CHAR_5 OS2(0x35,63)
#define KEY_CHAR_6 OS2(0x36,53)
#define KEY_CHAR_7 OS2(0x37,74)
#define KEY_CHAR_8 OS2(0x38,64)
#define KEY_CHAR_9 OS2(0x39,54)
#define KEY_CHAR_DP OS2(0x2e,61)
#define KEY_CHAR_EXP OS2(0x0f,51)
#define KEY_CHAR_PMINUS OS2(0x87,41)
#define KEY_CHAR_PLUS OS2(0x89,42)
#define KEY_CHAR_MINUS OS2(0x99,32)
#define KEY_CHAR_MULT OS2(0xa9,43)
#define KEY_CHAR_DIV OS2(0xb9,33)
#define KEY_CHAR_FRAC OS2(0xbb,75)
#define KEY_CHAR_LPAR OS2(0x28,55)
#define KEY_CHAR_RPAR OS2(0x29,45)
#define KEY_CHAR_COMMA OS2(0x2c,35)
#define KEY_CHAR_STORE OS2(0x0e,25)
#define KEY_CHAR_LOG OS2(0x95,66)
#define KEY_CHAR_LN OS2(0x85,56)
#define KEY_CHAR_SIN OS2(0x81,46)
#define KEY_CHAR_COS OS2(0x82,36)
#define KEY_CHAR_TAN OS2(0x83,26)
#define KEY_CHAR_SQUARE OS2(0x8b,67)
#define KEY_CHAR_POW OS2(0xa8,57)
#define KEY_CTRL_EXE OS2(30004,31)
#define KEY_CTRL_DEL OS2(30025,44)
#define KEY_CTRL_AC OS2(30015,32)
#define KEY_CTRL_FD OS2(30046,65)
#define KEY_CTRL_EXIT OS2(30002,47)
#define KEY_CTRL_SHIFT OS2(30006,78)
#define KEY_CTRL_ALPHA OS2(30007,77)
#define KEY_CTRL_OPTN OS2(30008,68)
#define KEY_CTRL_VARS OS2(30016,58)
#define KEY_CTRL_UP OS2(30018,28)
#define KEY_CTRL_DOWN OS2(30023,37)
#define KEY_CTRL_LEFT OS2(30020,38)
#define KEY_CTRL_RIGHT OS2(30021,27)
#define KEY_CTRL_F1 OS2(30009,79)
#define KEY_CTRL_F2 OS2(30010,69)
#define KEY_CTRL_F3 OS2(30011,59)
#define KEY_CTRL_F4 OS2(30012,49)
#define KEY_CTRL_F5 OS2(30013,39)
#define KEY_CTRL_F6 OS2(30014,29)
#define KEY_CTRL_MENU OS2(30003,48)

#ifndef isOS2// This is new

typedef int(*sc_i2cp2sip)(char*, char*, short int*, short int*);
const unsigned int sc0015[] = { 0xD201D002, 0x422B0009, 0x80010070, 0x0015 };
#define GlibGetOSVersionInfo (*(sc_i2cp2sip)sc0015)

int OSVersionAsInt(void){
    unsigned char mainversion;
    unsigned char minorversion;
    unsigned short release;
    unsigned short build;
    GlibGetOSVersionInfo( &mainversion, &minorversion, &release, &build );
    return ( ( mainversion << 24 ) & 0xFF000000 ) | ( ( minorversion << 16 ) & 0x00FF0000 ) | ( release & 0x0000FFFF );
}

#define isOS2 (OSVersionAsInt() >= 0x02020000)
#define OS2(x,y) ((OSVersionAsInt() >= 0x02020000)?y:x)

#endif

const unsigned short* keyboardregister = (unsigned short*)0xA44B0000;

unsigned short key[8] = {0};

int KeyDown(int keycode){
    if(isOS2){
        int row, col, word, bit;
        row = keycode%10;
        col = keycode/10-1;
        word = row>>1;
        bit = col + 8*(row&1);
        memcpy(key, keyboardregister, sizeof(unsigned short) << 3);
        Sleep(1); //slow down, this function is faster than IsKeyDown() :-P

        return (0 != (key[word] & 1<<bit));
    }
    else{
        return IsKeyDown(keycode);
    }
}

#define IsKeyDown(x) KeyDown(x)
#define IsKeyUp(x) !KeyDown(x)
/*ides :

->BEST DEPASSE :
    sur le BEST : afficher une image de flamme puis rempacer par TIME tout en laissant clignoter plusieurs fois

->SUCCES
    -"Amateur" Tenir plus de 5 sec
    -"Expert" Tenir plus de 10 sec
    -"Survivant" Tenir plus de 15 sec
    -"No-life" : Jouer au total 1h
    -"Cochon" : faire pil-poil 6.9 sec
    -"42" succs secret : avant que la partie commence (avant d'appuyer sur une flche), appuyer sur 4 et 2 en mme temps pour dcouvrir l'inertie. Ide d'image : 42
    -"Masochiste" : Avoir un autre die and retry (graviton)
    -"Quatre choix, c'est trop !" : tenir au moins 2 min sur le menu sans bouger
    -"Indcis" : mourir 50 fois sur le menu principal
    -"Fan"  : avoit tl fall down (version amlior : se fera avec la vrification de falldown.sav)
    -"L'alcool, c'est mal..." : tre tu par un bourr (atteindre 101 ou 102 pices : aller boire dans une taverne mais baston et un bourr te tue ^^ )
    -"Fin ?" : finir 1 fois le jeu
    -"entete" : 3 fois
    -"idee_fixe" : finir le jeu 5 fois
*/

#include "fxlib.h"
#include "MonochromeLib.h"
#include "memory.h"
#include "stdio.h"
#include "Stats.h"
#include "LibText.h"

#define FILEPATH "\\\\fls0\\evasion.sav"

/*
X High score 0
X #define AMATEUR 1
X #define EXPERT 2
X #define SURVIVANT 3
X #define BOURSE 4
X #define BOURSES 5
X #define TRESOR 6
X #define ALCOOL 7
X #define QUARANTE_DEUX 8
X #define NO_LIFE 9
X #define COCHON 10
X #define QUATRE_CHOIX 11
X #define INDECIS 12
X #define MASO 13
X #define FAN 14
X nb de partie 15
X temps de jeu 16
X temps de pause 17
X nb de fois que le jeu a ete fini 18
X nombre de pauses 19
X nb de parties quittees 20
X nb de morts sur le bord de la map 21
X nb de morts sur les obstacles 22
X nb de morts sur le menu 23
X nb de fois quon a active le succes 42 24
X nb de pieces 25
X nb de pieces collectees 26
*/

#define TAILLE 27*4

void jeu(int *recording, int *deverouillage);
void intro();
void transition(int a);
void afficher_obstacles(int *obstacle1, int *obstacle2, int *obstacle3, int *obstacle4);
void PrintVariable(int x, int y, int variable, int couleur);
int best_score(int compteur);
void transfert(int *tableau1, int *tableau2, int taille);
void direction(int *tableau, int vit_x, int vit_y, int color);

static int SysCallCode[] = {0xD201422B,0x60F20000,0x80010070};
static int (*SysCall)(int R4, int R5, int R6, int R7, int FNo ) = (void*)&SysCallCode;
int RTC_getTicks(void)
{
     return (*SysCall)(0, 0, 0, 0, 0x3B);
}
int SYS_call(void)
{
     return (*SysCall)(0, 0, 0, 0, 0x42);
}

void setFps(int fpsWish)
{
    static unsigned int fps = 0, fps_count = 0;

    do
    {
        fps = RTC_getTicks();
        Sleep(1);
    }
    while(fps < fps_count+fpsWish);
    fps_count = RTC_getTicks();
}


int AddIn_main(int isAppli, unsigned short OptionNum)
{
    int *recording = NULL, a; // on dclare un pointeur, au lieu du tableau
    const unsigned char MENU[]={0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3c, 0x3e, 0x1f, 0xe, 0xc, 0xff, 0xf, 0x0, 0x0, 0x0, 0x0, 0x3, 0xe3, 0x0, 0xf8, 0xc3, 0x7e, 0x7f, 0x3f, 0x9f, 0xc, 0xff, 0x1f, 0x80, 0x0, 0x0, 0x0, 0x7, 0xf3, 0x1, 0xfc, 0xc3, 0xe0, 0x63, 0x30, 0x19, 0x80, 0x18, 0x30, 0x0, 0x0, 0x0, 0x0, 0x6, 0x33, 0x1, 0x8c, 0xc3, 0xc0, 0x63, 0x30, 0x18, 0xcc, 0x18, 0x30, 0x0, 0x0, 0x0, 0x0, 0x6, 0x33, 0x1, 0x8c, 0xc3, 0xc0, 0x7f, 0x38, 0x18, 0xcc, 0x18, 0x1f, 0x0, 0x0, 0x0, 0x0, 0x7, 0xf3, 0x1, 0x8c, 0x66, 0xc0, 0x7e, 0x3e, 0x18, 0xcc, 0x18, 0xf, 0x80, 0x0, 0x0, 0x0, 0x7, 0xe3, 0x1, 0xfc, 0x3c, 0xc0, 0x6c, 0x38, 0x18, 0xcc, 0x18, 0x0, 0xc0, 0x0, 0x0, 0x0, 0x6, 0x3, 0x1, 0xfc, 0x18, 0xc0, 0x6c, 0x30, 0x18, 0xcc, 0x18, 0x0, 0xc0, 0x0, 0x0, 0x0, 0x6, 0x3, 0x1, 0x8c, 0x18, 0xe0, 0x66, 0x30, 0x19, 0x8c, 0x18, 0x0, 0xc0, 0x0, 0x0, 0x0, 0x6, 0x3, 0x1, 0x8c, 0x18, 0x7e, 0x66, 0x3f, 0x9f, 0xc, 0x18, 0x1f, 0x80, 0x0, 0x0, 0x0, 0x6, 0x3, 0xf9, 0x8c, 0x18, 0x3c, 0x63, 0x1f, 0xe, 0xc, 0x18, 0xf, 0x0, 0x0, 0x0, 0x0, 0x6, 0x3, 0xf9, 0x8c, 0x18, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x5, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x50, 0x0, 0x0, 0x0, 0x0, 0x6, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x80, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xb7, 0x68, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xb0, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x80, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xb8, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xad, 0xe8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xbc, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x80, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xbe, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xbb, 0xa8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xbc, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x80, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xb8, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xb5, 0xa8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xb0, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x80, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x5, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x5, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x5, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3f, 0xff, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x80, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x0, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xb0, 0x68, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x28, 0x2, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x6, 0xb8, 0xe8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x4, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x5, 0x9d, 0xc8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x28, 0x24, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x8f, 0x88, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0xd8, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x5, 0x87, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x29, 0x0, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x8f, 0x88, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x21, 0x0, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x5, 0x9d, 0xc8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2a, 0x0, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x6, 0xb8, 0xe8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x24, 0x0, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xb0, 0x68, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2a, 0xaa, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x80, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x20, 0x0, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x5, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xd0, 0x0, 0x0, 0x0, 0x0, 0x6, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xb0, 0x0, 0x0, 0x0, 0x0, 0x5, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x50, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7c, 0x63, 0x33, 0xfc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xfe, 0x63, 0x33, 0xfc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0x1f, 0xe3, 0xe3, 0xfc, 0x3c, 0xc6, 0x63, 0x0, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0x9f, 0xe7, 0xf3, 0xfc, 0x7e, 0xc6, 0x63, 0x30, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x30, 0x3, 0x6, 0x30, 0x60, 0xc0, 0xc6, 0x63, 0x30, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x30, 0x3, 0x6, 0x30, 0x60, 0xc0, 0xc6, 0x63, 0x30, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0x3, 0x6, 0x30, 0x60, 0x7c, 0xc6, 0x63, 0x30, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0x83, 0x7, 0xf0, 0x60, 0x3e, 0xc6, 0x63, 0x30, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xc3, 0x7, 0xf0, 0x60, 0x3, 0xce, 0x63, 0x30, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xc3, 0x6, 0x30, 0x60, 0x3, 0xfe, 0x7f, 0x30, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xc3, 0x6, 0x30, 0x60, 0x3, 0x7f, 0x3e, 0x30, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0x83, 0x6, 0x30, 0x60, 0x7e, 0x3, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0x3, 0x6, 0x30, 0x60, 0x3c, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
    const unsigned char Explosion[9][54]={
        {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3,0xf0,0x0,0x2,0x30,0x0,0x2,0x90,0x0,0x2,0x50,0x0,0x3,0x10,0x0,0x3,0xf0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0},
        {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3,0xd0,0x0,0x2,0xa0,0x0,0x3,0x50,0x0,0x2,0xb0,0x0,0x1,0x50,0x0,0x2,0xf0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0},
        {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x10,0x0,0x1,0x58,0x0,0x6,0xa0,0x0,0x1,0x90,0x0,0x2,0x60,0x0,0x1,0x58,0x0,0x6,0xa0,0x0,0x2,0x20,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0},
        {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x8,0x0,0x1,0x10,0x0,0x5,0x42,0x0,0x0,0x4,0x0,0x1d,0xa0,0x0,0x1,0x8,0x0,0x4,0x20,0x0,0x1,0x6e,0x0,0x8,0x0,0x0,0x10,0xa8,0x0,0x2,0x20,0x0,0x4,0x20,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0},
        {0x0,0x0,0x0,0x0,0x80,0x0,0x2,0x14,0x0,0x9,0x10,0x0,0x18,0xc1,0x0,0x0,0x0,0x0,0x21,0x33,0x0,0x13,0x10,0x0,0x40,0x46,0x0,0x18,0x80,0x80,0x2,0x32,0x0,0x33,0x21,0x0,0x0,0x0,0x0,0x20,0xc6,0x0,0x2,0x24,0x0,0xa,0x10,0x0,0x0,0x40,0x0,0x0,0x0,0x0},
        {0x0,0x8,0x0,0x10,0x8b,0x0,0x12,0x0,0x80,0x61,0x0,0x80,0x8,0xc0,0x0,0x2,0x10,0xc0,0x64,0x98,0x0,0x1,0x20,0x0,0x86,0x83,0x0,0x30,0x58,0x40,0x1,0x20,0x0,0x6,0x49,0x80,0xc2,0x10,0x0,0x0,0xc4,0x0,0x40,0x21,0x80,0x40,0x12,0x0,0x34,0x42,0x0,0x4,0x0,0x0},
        {0x8,0x84,0x0,0x2,0x0,0x80,0x22,0x0,0x0,0x0,0x40,0x0,0x8a,0x10,0x40,0x0,0x80,0x0,0x12,0x14,0x0,0x80,0x80,0x0,0x11,0x4,0x80,0x48,0x22,0x0,0x0,0x40,0x40,0xa,0x12,0x0,0x0,0x40,0x0,0x82,0x14,0x40,0x0,0x80,0x0,0x0,0x11,0x0,0x40,0x10,0x0,0x8,0x44,0x0},
        {0x0,0x0,0x0,0x0,0x0,0x0,0x2,0x40,0x0,0x0,0x0,0x0,0xa,0x8,0x0,0x0,0x80,0x0,0x20,0x52,0x0,0x8,0x2,0x0,0x20,0x8,0x0,0x4,0x1,0x0,0x10,0x4,0x0,0x12,0x81,0x0,0x0,0x40,0x0,0x4,0x14,0x0,0x0,0x0,0x0,0x0,0x90,0x0,0x0,0x0,0x0,0x0,0x0,0x0},
        {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2,0x0,0x0,0x0,0x80,0x0,0x0,0x29,0x0,0x10,0x0,0x0,0x0,0x0,0x0,0x8,0x0,0x0,0x0,0x4,0x0,0x0,0x0,0x0,0x0,0x2,0x0,0x25,0x0,0x0,0x0,0x40,0x0,0x0,0x10,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0}
    };
    const unsigned char CAMENBERT[]={0x0, 0x0, 0x3c, 0x0, 0x0, 0x0, 0x7, 0xff, 0xe0, 0x0, 0x0, 0x1f, 0xcb, 0xf8, 0x0, 0x0, 0x30, 0x88, 0x1c, 0x0, 0x0, 0xf0, 0x88, 0x7, 0x0, 0x1, 0x88, 0x88, 0x3, 0x80, 0x3, 0x8, 0x48, 0x0, 0xc0, 0x6, 0x4, 0x48, 0x0, 0x60, 0xe, 0x4, 0x48, 0x0, 0x30, 0x19, 0x2, 0x48, 0x0, 0x18, 0x18, 0x82, 0x48, 0x0, 0x18, 0x30, 0x61, 0x48, 0x0, 0xc, 0x60, 0x11, 0x28, 0x0, 0x6, 0x60, 0x8, 0xa8, 0x0, 0x6, 0x60, 0x4, 0xa8, 0x0, 0x6, 0x60, 0x2, 0x68, 0x0, 0x6, 0x7c, 0x1, 0xe8, 0x0, 0x6, 0xc3, 0xf0, 0x78, 0x0, 0x3, 0xc0, 0xf, 0xb8, 0x0, 0x3, 0xc0, 0x0, 0x78, 0x0, 0x3, 0xc0, 0x0, 0x18, 0x0, 0x3, 0xc0, 0x0, 0x28, 0x0, 0x3, 0xc0, 0x0, 0x44, 0x0, 0x3, 0x60, 0x1, 0x84, 0x0, 0x6, 0x60, 0x2, 0x2, 0x0, 0x6, 0x60, 0x4, 0x2, 0x0, 0x6, 0x60, 0x8, 0x2, 0x0, 0x6, 0x60, 0x10, 0x1, 0x0, 0x6, 0x30, 0x60, 0x1, 0x0, 0xc, 0x18, 0x80, 0x0, 0x80, 0x18, 0x19, 0x0, 0x0, 0x80, 0x18, 0xe, 0x0, 0x0, 0x80, 0x30, 0x4, 0x0, 0x0, 0x40, 0x60, 0x7, 0x0, 0x0, 0x40, 0x60, 0x3, 0x80, 0x0, 0x21, 0xc0, 0x0, 0xe0, 0x0, 0x27, 0x0, 0x0, 0x78, 0x0, 0x1e, 0x0, 0x0, 0x1f, 0xc3, 0xf8, 0x0, 0x0, 0x7, 0xff, 0xe0, 0x0, 0x0, 0x0, 0x3c, 0x0, 0x0};
    const unsigned char CRISTAL[]={0x0, 0x7f, 0xff, 0xff, 0x0, 0x0, 0x8c, 0xe3, 0x98, 0x80, 0x0, 0x8c, 0xe3, 0x98, 0x80, 0x0, 0xcc, 0xe3, 0x99, 0x80, 0x0, 0xcc, 0xe3, 0x99, 0x80, 0x0, 0x4c, 0xe3, 0x99, 0x0, 0x0, 0x2c, 0xe3, 0x9a, 0x0, 0x0, 0x1c, 0xe3, 0x9c, 0x0, 0x0, 0xc, 0xe3, 0x98, 0x0, 0x0, 0x4, 0xe3, 0x90, 0x0, 0x0, 0x2, 0xeb, 0xa0, 0x0, 0x0, 0x1, 0xf7, 0xc0, 0x0, 0x0, 0x0, 0xe3, 0x80, 0x0, 0x0, 0x1, 0xc1, 0xc0, 0x0, 0x0, 0x1, 0x41, 0x40, 0x0, 0x0, 0x1f, 0xa2, 0x7c, 0x0, 0x0, 0x10, 0xd4, 0x84, 0x0, 0x0, 0x10, 0xe8, 0x84, 0x0, 0x0, 0x10, 0x71, 0x4, 0x0, 0x0, 0x70, 0x71, 0x7, 0x0, 0x0, 0x4e, 0x33, 0x19, 0x0, 0x0, 0xe3, 0x32, 0xe2, 0x80, 0x1, 0x70, 0xf1, 0x84, 0x40, 0x2, 0x38, 0x10, 0x8, 0x20, 0x4, 0x4, 0x0, 0x10, 0x10, 0x2, 0x1f, 0xf7, 0xf8, 0x20, 0x1, 0x3f, 0xf3, 0xfc, 0x40, 0x0, 0xff, 0xb2, 0xfe, 0x80, 0x0, 0x7f, 0x73, 0x7f, 0x0, 0x0, 0x70, 0xf1, 0x87, 0x0, 0x0, 0x10, 0xf1, 0x4, 0x0, 0x0, 0x10, 0xf8, 0x84, 0x0, 0x0, 0x10, 0xf4, 0x84, 0x0, 0x0, 0x1f, 0xe2, 0x7c, 0x0, 0x0, 0x1, 0xc1, 0x40, 0x0, 0x0, 0x1, 0x80, 0xc0, 0x0, 0x0, 0x0, 0x41, 0x0, 0x0, 0x0, 0x0, 0x22, 0x0, 0x0, 0x0, 0x0, 0x14, 0x0, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0};
    const unsigned char escapethedeath[]={0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3f, 0xff, 0xc0, 0x1f, 0xe0, 0x0, 0x3f, 0xe0, 0x0, 0x30, 0x0, 0x7f, 0xff, 0x7, 0xff, 0xf8, 0xf, 0xff, 0xc0, 0x7f, 0xf0, 0x1, 0xff, 0xf0, 0x0, 0x38, 0x0, 0xf, 0xff, 0xc1, 0xff, 0xf8, 0x7, 0x80, 0xc0, 0xf0, 0x78, 0x3, 0xe0, 0x78, 0x0, 0x78, 0x0, 0xf, 0x7, 0xe0, 0xf0, 0x18, 0x7, 0x80, 0xc1, 0xe0, 0x18, 0xf, 0x80, 0x18, 0x0, 0x7c, 0x0, 0xf, 0x3, 0xe0, 0xf0, 0x18, 0x7, 0x80, 0xc1, 0xc0, 0x10, 0xf, 0x0, 0x0, 0x0, 0xfc, 0x0, 0xf, 0x3, 0xe0, 0xf0, 0x18, 0x7, 0x80, 0x3, 0xc0, 0x0, 0x1e, 0x0, 0x0, 0x0, 0xfe, 0x0, 0xf, 0x1, 0xe0, 0xf0, 0x0, 0x7, 0x80, 0x3, 0xc0, 0x0, 0x3e, 0x0, 0x0, 0x0, 0xbe, 0x0, 0xf, 0x1, 0xe0, 0xf0, 0x0, 0x7, 0x81, 0x3, 0xe0, 0x0, 0x3e, 0x0, 0x0, 0x1, 0x9e, 0x0, 0xf, 0x3, 0xe0, 0xf0, 0x20, 0x7, 0x81, 0x3, 0xf8, 0x0, 0x3c, 0x0, 0x0, 0x1, 0x9f, 0x0, 0xf, 0x3, 0xc0, 0xf0, 0x20, 0x7, 0xff, 0x1, 0xff, 0x0, 0x3c, 0x0, 0x0, 0x3, 0xf, 0x0, 0xf, 0x7, 0x80, 0xff, 0xe0, 0x7, 0xff, 0x0, 0xff, 0xf0, 0x3c, 0x0, 0x0, 0x3, 0xf, 0x80, 0xf, 0x7f, 0x0, 0xff, 0xe0, 0x7, 0x81, 0x0, 0x7f, 0xf8, 0x3c, 0x0, 0x0, 0x2, 0xf, 0x80, 0xf, 0x3e, 0x0, 0xf0, 0x20, 0x7, 0x81, 0x0, 0xf, 0xfc, 0x3c, 0x0, 0x0, 0x6, 0x7, 0xc0, 0xf, 0x0, 0x0, 0xf0, 0x20, 0x7, 0x80, 0x0, 0x1, 0xfc, 0x3e, 0x0, 0x0, 0x7, 0xff, 0xc0, 0xf, 0x0, 0x0, 0xf0, 0x0, 0x7, 0x80, 0x0, 0x0, 0x7c, 0x3e, 0x0, 0x0, 0xf, 0xff, 0xc0, 0xf, 0x0, 0x0, 0xf0, 0x0, 0x7, 0x80, 0x2, 0x0, 0x3c, 0x1e, 0x0, 0x0, 0xc, 0x3, 0xe0, 0xf, 0x0, 0x0, 0xf0, 0x0, 0x7, 0x80, 0x2, 0x0, 0x3c, 0x1f, 0x0, 0x0, 0xc, 0x3, 0xe0, 0xf, 0x0, 0x0, 0xf0, 0x0, 0x7, 0x80, 0xc3, 0x0, 0x3c, 0xf, 0x80, 0x0, 0x18, 0x1, 0xf0, 0xf, 0x0, 0x0, 0xf0, 0x18, 0x7, 0x80, 0xc3, 0x0, 0x38, 0xf, 0xc0, 0x4, 0x18, 0x1, 0xf0, 0xf, 0x0, 0x0, 0xf0, 0x18, 0x7, 0x80, 0xc3, 0xc0, 0xf0, 0x7, 0xf0, 0x18, 0x38, 0x0, 0xf8, 0xf, 0x0, 0x0, 0xff, 0xf8, 0x7, 0xff, 0xc1, 0xff, 0xe0, 0x1, 0xff, 0xf0, 0x30, 0x0, 0xf8, 0xf, 0x80, 0x3, 0xff, 0xf8, 0x1f, 0xff, 0xc0, 0xff, 0x80, 0x0, 0x3f, 0xc0, 0xfe, 0x7, 0xfe, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x31, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x31, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7d, 0xb8, 0x78, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x31, 0xcc, 0xcc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x31, 0x8c, 0xcc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x31, 0x8c, 0xfc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x31, 0x8c, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x31, 0x8c, 0xcc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3d, 0xdc, 0x78, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x80, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x3, 0xe0, 0x3, 0xfe, 0x7, 0xfe, 0x3, 0x81, 0xff, 0xcf, 0x8f, 0x80, 0xf, 0x80, 0x0, 0x0, 0x3, 0xf8, 0x1, 0xc7, 0x83, 0x86, 0x3, 0x81, 0x9c, 0xc7, 0x7, 0x0, 0x3f, 0x80, 0x0, 0x7f, 0xff, 0xfc, 0x1, 0xc1, 0xc3, 0x86, 0x7, 0x81, 0x1c, 0x47, 0x7, 0x0, 0x7f, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0x1, 0xc1, 0xc3, 0x80, 0x5, 0xc1, 0x1c, 0x47, 0x7, 0x1, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xc1, 0xc1, 0xe3, 0x80, 0xd, 0xc0, 0x1c, 0x7, 0x7, 0x7, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xf1, 0xc0, 0xe3, 0x88, 0x9, 0xc0, 0x1c, 0x7, 0x7, 0x1f, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xf9, 0xc0, 0xe3, 0xf8, 0x8, 0xe0, 0x1c, 0x7, 0xff, 0x3f, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xf1, 0xc0, 0xe3, 0x88, 0x18, 0xe0, 0x1c, 0x7, 0x7, 0x1f, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xc1, 0xc0, 0xe3, 0x80, 0x10, 0xe0, 0x1c, 0x7, 0x7, 0x7, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0x1, 0xc1, 0xc3, 0x80, 0x3f, 0xf0, 0x1c, 0x7, 0x7, 0x1, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xfc, 0x1, 0xc1, 0xc3, 0x86, 0x30, 0x70, 0x1c, 0x7, 0x7, 0x0, 0x7f, 0xff, 0xfc, 0x0, 0x3, 0xf8, 0x1, 0xc1, 0x83, 0x86, 0x20, 0x70, 0x1c, 0x7, 0x7, 0x0, 0x3f, 0x80, 0x0, 0x0, 0x3, 0xe0, 0x1, 0xc3, 0x3, 0x86, 0x60, 0x78, 0x1c, 0x7, 0x7, 0x0, 0xf, 0x80, 0x0, 0x0, 0x3, 0x80, 0x3, 0xfe, 0x7, 0xfe, 0xf0, 0xfc, 0x3e, 0xf, 0x8f, 0x80, 0x3, 0x80, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
    int deverouillage[]={0, 0, 0, 0, 0 ,0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
    int carre_x=62, carre_y=30, shift, i, choix, temps_ecoule, temps_actuel, temps_reference, sec=0, min=0, place=0, x, y, ret;
    float cent_sec=0.0;

    Bdisp_AllClr_DDVRAM();
    Txt_Init(FONT_SERIFBOLD | FONT_ARCADIUM |FONT_SERIF | FONT_7SEG | FONT_7SEGMINI);

    recording = memory_load(FILEPATH); // on charge les donnes
    if(recording == NULL){
        int data[28] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
        memory_save(FILEPATH, data, TAILLE); // on essaie de crer un fichier vide
        recording = memory_load(FILEPATH);
        if(recording == NULL){ // si a a pas march on affiche un message disant que la calto est pourrave et que Lephenix code avec les pieds : DECLARATION DE DARK STORM :p
            PrintMini(0, 0,  (const unsigned char *)"Une erreur est survenue lors   ", 1);
            PrintMini(0, 8,  (const unsigned char *)"de la creation du fichier de   ", 1);
            PrintMini(0, 16, (const unsigned char *)"sauvegarde. Veuillez verifiez  ", 1);
            PrintMini(0, 24, (const unsigned char *)"s'il vous reste de la place    ", 1);
            PrintMini(0, 32, (const unsigned char *)"dans la memoire de stockage.   ", 1);
            PrintMini(0, 40, (const unsigned char *)"Si le probleme persiste,       ", 1);
            PrintMini(0, 48, (const unsigned char *)"laissez un message sur la page ", 1);
            PrintMini(0, 56, (const unsigned char *)"web \" http://www.planet-casio.", 1);
            ML_display_vram();
            while(IsKeyUp(KEY_CTRL_EXE));
            while(IsKeyDown(KEY_CTRL_EXE));
            ML_clear_vram();
            PrintMini(0, 0,  (const unsigned char *)"com/Fr/programmes/programme2", 1);
            PrintMini(0, 8,  (const unsigned char *)"435-1-memory-LePhenixNoir-add-", 1);
            PrintMini(0, 16, (const unsigned char *)"in.html \"", 1);
            ML_display_vram();
            while(IsKeyUp(KEY_CTRL_EXE));
            return 1;
        }
        for(a=0; a<25; a++) recording[a]=0;     //des fois cela n'initialisait pas correctement donc jai pris cette precaution
        intro();
        again(1);
    }
    else{
        srand(RTC_getTicks());
        for(i=0; i<=20; i++){
            ML_clear_vram();
            x=rand()%10;
            y=rand()%10;
            ML_bmp_or_cl(escapethedeath, x-5, y-5, 128, 64);          //on affiche l'cran
            ML_display_vram();
            Sleep(15);
        }
    }
    ML_clear_vram();
    ML_bmp_or(escapethedeath, 0, 0, 128, 64);
    ML_display_vram();
    Sleep(1500);

    if(memory_exists("\\\\fls0\\graviton.SAV") && !recording[13]){
        deverouillage[place]=13;
        place++;
    }
    if(memory_exists("\\\\fls0\\falldown.SAV") && !recording[14]){
        deverouillage[place]=14;
        place++;
    }
    ML_clear_vram();
    ML_bmp_or(MENU, 0, 0, 128, 64);
    temps_reference = RTC_getTicks();
    while(1){
        ML_rectangle(25, 27, 103, 33, 1, 0, 0);     //ici on efface la ou le carre peut se deplacer sans tout effacer,
        ML_rectangle(37, 17, 92, 26, 1, 0, 0);      //ce qui permet de ne pas tout re-afficher
        ML_rectangle(37, 34, 89, 45, 1, 0, 0);
        ML_rectangle(carre_x, carre_y, carre_x+5, carre_y+5, 1, 1, 0);
        if(IsKeyDown(KEY_CTRL_SHIFT))   shift=2;    //acclration ou non suivant si shift est press
        else    shift=1;
        if(IsKeyDown(KEY_CTRL_UP))      carre_y-=2*shift; //dplacement du carr selon les touches
        if(IsKeyDown(KEY_CTRL_RIGHT))   carre_x+=2*shift;
        if(IsKeyDown(KEY_CTRL_DOWN))    carre_y+=2*shift;
        if(IsKeyDown(KEY_CTRL_LEFT))    carre_x-=2*shift;

        if(carre_x<=24 || carre_x>=99 || carre_y<=16 || carre_y>=41){ //si on meurt comme un con...
            for(i=0; i<9; i++){     //explosion du carr
                ML_bmp_and(MENU, 0, 0, 128, 64);
                ML_bmp_or(MENU, 0, 0, 128, 64);
                PrintMini(110, 25, (const unsigned char *)"Pieces", 1);
                PrintVariable(115, 33, recording[25], 1);
                ML_bmp_or_cl(Explosion[i], carre_x-6, carre_y-6, 18, 18);
                ML_display_vram();
                Sleep(40);
            }
            carre_x=62;
            carre_y=30;
            ML_clear_vram();
            ML_bmp_or(MENU, 0, 0, 128, 64);
            recording[23]++;
            memory_save(FILEPATH, recording, TAILLE);
        }
        ML_display_vram();
        if(carre_x<=36 && carre_y<=26 || carre_x>=88 && carre_y<=26 || carre_x>=85 && carre_y>=29 || carre_x<=36 && carre_y>=29){//si on va dans un menu
            i=0;
            while(IsKeyDown(KEY_CTRL_UP) || IsKeyDown(KEY_CTRL_RIGHT) || IsKeyDown(KEY_CTRL_DOWN) || IsKeyDown(KEY_CTRL_LEFT));     //tant qu'on appuie sur une fleche de direction

            recording = memory_load(FILEPATH);
            if(carre_x>=88 && carre_y<=26)  jeu(recording, deverouillage);
            if(carre_x<=36 && carre_y<=26)  credits();
            if(carre_x>=85 && carre_y>=29){
                for(i=-40; i<14; i++){
                    ML_clear_vram();
                    ML_bmp_or_cl(CAMENBERT, 20, i, 40, 40);
                    ML_bmp_or_cl(CRISTAL, 68, 28-i, 40, 40);
                    ML_display_vram();
                    Sleep(20);
                }
                choix=0;
                do{
                    if(IsKeyDown(KEY_CTRL_RIGHT) && choix==0)   choix=1;
                    if(IsKeyDown(KEY_CTRL_LEFT) && choix==1)   choix=0;
                    ML_clear_vram();
                    ML_rectangle(17+48*choix, 11, 62+48*choix, 56, 2, 3, ML_TRANSPARENT);
                    ML_rectangle(19+48*choix, 13, 60+48*choix, 54, 1, 1, ML_TRANSPARENT);
                    ML_rectangle(16+48*choix, 10, 63+48*choix, 57, 1, 1, ML_TRANSPARENT);
                    ML_bmp_or(CAMENBERT, 20, i, 40, 40);
                    ML_bmp_or(CRISTAL, 68, 28-i, 40, 40);
                    if(!choix) Txt_Text("Statistiques", 34, 1, TXT_7SEG, TXT_OR);
                    else    Txt_Text("Succes", 46, 1, TXT_SERIF, TXT_OR);
                    ML_display_vram();
                }while(IsKeyUp(KEY_CTRL_EXE));
                ML_rectangle(19+48*choix, 13, 60+48*choix, 54, 1, 1, 2);
                ML_display_vram();
                while(IsKeyDown(KEY_CTRL_EXE));

                if(choix)   succes(recording, deverouillage);
                else statisques(recording);
            }
            if(carre_x<=36 && carre_y>=29){
                memory_save(FILEPATH, recording, TAILLE);
                break;
            }
            carre_x=62;
            carre_y=30;
            ML_clear_vram();
            ML_bmp_or(MENU, 0, 0, 128, 64);
        }
        if(recording[25]>99){
            ret=magasin(recording[25], recording[7]);
            again(0);
            recording[18]++;
            recording[25]=0;
            if(!recording[4]){
                deverouillage[place]=4;
                place++;
            }
            if(!recording[5] && recording[18]>2){
                deverouillage[place]=5;
                place++;
            }
            if(!recording[6] && recording[18]>4){
                deverouillage[place]=6;
                place++;
            }
            if(!recording[7] && ret==6){
                deverouillage[place]=7;
                place++;
            }
            memory_save(FILEPATH, recording, TAILLE);
            ML_clear_vram();
            ML_bmp_or(MENU, 0, 0, 128, 64);
            ML_display_vram();
        }
        PrintMini(110, 25, (const unsigned char *)"Pieces", 1);
        PrintVariable(115, 33, recording[25], 1);
        if(IsKeyDown(KEY_CTRL_UP) || IsKeyDown(KEY_CTRL_RIGHT) || IsKeyDown(KEY_CTRL_DOWN) || IsKeyDown(KEY_CTRL_LEFT)){
            sec=0;
            min=0;
            cent_sec=0;
        }
        temps_actuel = RTC_getTicks();
        temps_ecoule = (int)((temps_actuel - temps_reference) / 1.28);
        cent_sec=temps_ecoule;

        if(cent_sec>=100){
            temps_reference = RTC_getTicks();       //si les centimes de sec sont  100, on remet le temps rfrence  0
            cent_sec-=100;
            sec++;                                  //et on Isz les sec ;)
        }
        if(sec>=60){
            sec-=60;
            min++;
        }
        if(min==2 && !recording[11]){
            deverouillage[place]=11;
            place++;
        }
        if(recording[23]>=50 && !recording[12]){
            deverouillage[place]=12;
            place++;
        }
        if(deverouillage[0]){
            succes(recording, deverouillage);
            place=0;
            ML_clear_vram();
            ML_bmp_or(MENU, 0, 0, 128, 64);
            memory_save(FILEPATH, recording, TAILLE);
        }
        setFps( 4 ); // pour rguler  32 FPS
    }
    Txt_Quit();
    return 1;
}


void jeu(int *recording, int *deverouillage){
    float record=0.0;
    int carre_x=30+32, carre_y=30;
    int vitesse_obs1_x=1, vitesse_obs1_y=1, vitesse_obs2_x=-1, vitesse_obs2_y=1, vitesse_obs3_x=1, vitesse_obs3_y=-1, vitesse_obs4_x=-1, vitesse_obs4_y=-1;
    int shift=1, i, ii, temps_ecoule, sec=0, min=0, sec_rec=0, min_rec=0, compteur_xor, stop, direc, disposition, quardeux=0;
    float temps_reference=0.0, temps_actuel=0.0, score=0.0, cent_sec_rec=0.0, cent_sec=0.0, temps_pause_reference=0.0, temps_pause_ecoule=0.0, temps_pause_partie=0.0;


    unsigned char burst[5][200] = {
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 255, 0, 0, 0, 7, 255, 128, 0, 0, 15, 231, 224, 0, 0, 31, 131, 240, 0, 0, 63, 0, 240, 0, 0, 62, 1, 120, 0, 0, 120, 1, 8, 0, 0, 120, 0, 252, 0, 0, 120, 128, 28, 0, 0, 112, 0, 44, 0, 0, 96, 0, 124, 0, 0, 112, 0, 28, 0, 0, 112, 0, 28, 0, 0, 120, 0, 60, 0, 0, 120, 24, 188, 0, 0, 56, 16, 184, 0, 0, 59, 0, 248, 0, 0, 14, 152, 240, 0, 0, 7, 151, 224, 0, 0, 7, 239, 128, 0, 0, 1, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 255, 128, 0, 0, 15, 255, 224, 0, 0, 31, 159, 224, 0, 0, 63, 19, 240, 0, 0, 124, 241, 120, 0, 0, 248, 1, 252, 0, 1, 244, 0, 126, 0, 3, 38, 0, 31, 0, 3, 176, 0, 15, 0, 3, 248, 2, 31, 0, 3, 128, 3, 31, 128, 3, 64, 1, 15, 128, 3, 240, 0, 3, 128, 3, 120, 0, 3, 128, 3, 128, 0, 7, 128, 3, 128, 0, 15, 128, 3, 192, 0, 23, 0, 3, 192, 64, 7, 0, 3, 232, 96, 31, 0, 1, 232, 32, 30, 0, 1, 248, 0, 222, 0, 0, 120, 98, 120, 0, 0, 59, 107, 240, 0, 0, 31, 179, 224, 0, 0, 15, 223, 224, 0, 0, 7, 255, 128, 0, 0, 0, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 0, 0, 0, 3, 255, 224, 0, 0, 15, 251, 248, 0, 0, 31, 157, 252, 0, 0, 63, 230, 254, 0, 0, 125, 246, 63, 0, 0, 255, 254, 255, 128, 1, 247, 127, 255, 192, 1, 227, 159, 255, 192, 3, 255, 30, 251, 224, 3, 143, 14, 97, 224, 3, 175, 14, 33, 224, 7, 223, 63, 128, 240, 7, 254, 31, 176, 240, 7, 238, 14, 126, 112, 7, 224, 4, 255, 112, 7, 128, 192, 247, 240, 7, 199, 192, 29, 112, 7, 207, 227, 159, 240, 3, 255, 227, 207, 224, 3, 254, 1, 223, 224, 3, 249, 140, 255, 224, 1, 227, 222, 127, 192, 1, 255, 255, 63, 192, 0, 255, 255, 143, 128, 0, 127, 158, 255, 0, 0, 63, 152, 254, 0, 0, 31, 249, 252, 0, 0, 15, 255, 248, 0, 0, 3, 255, 224, 0, 0, 0, 127, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 192, 0, 0, 3, 255, 248, 0, 0, 31, 253, 255, 0, 0, 63, 239, 255, 0, 0, 63, 207, 255, 0, 0, 121, 247, 255, 224, 0, 112, 255, 255, 240, 3, 255, 255, 255, 184, 7, 239, 63, 255, 156, 7, 230, 127, 255, 220, 15, 243, 255, 255, 252, 15, 255, 254, 63, 252, 15, 255, 255, 143, 248, 14, 127, 255, 239, 224, 28, 255, 255, 255, 252, 62, 127, 255, 255, 252, 63, 255, 255, 255, 60, 63, 191, 255, 254, 28, 63, 63, 255, 252, 204, 62, 63, 255, 255, 220, 63, 63, 255, 255, 204, 63, 255, 255, 255, 252, 63, 255, 255, 255, 240, 31, 255, 255, 255, 248, 31, 249, 249, 255, 248, 31, 243, 252, 255, 248, 15, 247, 126, 127, 248, 15, 255, 63, 247, 248, 15, 255, 63, 241, 248, 7, 255, 191, 227, 240, 1, 255, 159, 231, 224, 0, 127, 159, 239, 192, 0, 63, 223, 255, 128, 0, 63, 254, 255, 0, 0, 31, 252, 254, 0, 0, 7, 248, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
        { 0, 0, 124, 0, 0, 0, 0, 254, 0, 0, 0, 1, 254, 240, 0, 0, 241, 249, 254, 0, 1, 248, 253, 254, 0, 1, 254, 249, 254, 0, 1, 206, 83, 252, 192, 1, 135, 87, 249, 224, 28, 255, 119, 251, 112, 60, 249, 128, 1, 56, 60, 179, 145, 225, 184, 30, 159, 191, 251, 248, 110, 127, 28, 123, 248, 114, 124, 15, 25, 192, 120, 64, 207, 220, 0, 126, 19, 231, 241, 252, 255, 157, 192, 35, 255, 255, 156, 0, 7, 159, 255, 64, 63, 23, 15, 255, 64, 239, 134, 7, 254, 67, 239, 134, 103, 254, 67, 239, 15, 102, 252, 137, 239, 39, 254, 255, 184, 252, 115, 252, 255, 60, 56, 251, 224, 248, 126, 7, 248, 4, 51, 127, 15, 248, 0, 7, 51, 157, 248, 56, 15, 158, 31, 241, 252, 15, 128, 15, 179, 252, 31, 192, 227, 195, 252, 31, 207, 240, 8, 252, 15, 159, 120, 113, 248, 3, 63, 62, 115, 240, 0, 63, 63, 119, 224, 0, 119, 191, 127, 192, 0, 103, 255, 127, 128, 0, 3, 254, 127, 0, 0, 3, 252, 56, 0, 0, 0, 240, 0, 0 }
    };
    const unsigned char Explosion[9][54]={
        {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3,0xf0,0x0,0x2,0x30,0x0,0x2,0x90,0x0,0x2,0x50,0x0,0x3,0x10,0x0,0x3,0xf0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0},
        {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3,0xd0,0x0,0x2,0xa0,0x0,0x3,0x50,0x0,0x2,0xb0,0x0,0x1,0x50,0x0,0x2,0xf0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0},
        {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x10,0x0,0x1,0x58,0x0,0x6,0xa0,0x0,0x1,0x90,0x0,0x2,0x60,0x0,0x1,0x58,0x0,0x6,0xa0,0x0,0x2,0x20,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0},
        {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x8,0x0,0x1,0x10,0x0,0x5,0x42,0x0,0x0,0x4,0x0,0x1d,0xa0,0x0,0x1,0x8,0x0,0x4,0x20,0x0,0x1,0x6e,0x0,0x8,0x0,0x0,0x10,0xa8,0x0,0x2,0x20,0x0,0x4,0x20,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0},
        {0x0,0x0,0x0,0x0,0x80,0x0,0x2,0x14,0x0,0x9,0x10,0x0,0x18,0xc1,0x0,0x0,0x0,0x0,0x21,0x33,0x0,0x13,0x10,0x0,0x40,0x46,0x0,0x18,0x80,0x80,0x2,0x32,0x0,0x33,0x21,0x0,0x0,0x0,0x0,0x20,0xc6,0x0,0x2,0x24,0x0,0xa,0x10,0x0,0x0,0x40,0x0,0x0,0x0,0x0},
        {0x0,0x8,0x0,0x10,0x8b,0x0,0x12,0x0,0x80,0x61,0x0,0x80,0x8,0xc0,0x0,0x2,0x10,0xc0,0x64,0x98,0x0,0x1,0x20,0x0,0x86,0x83,0x0,0x30,0x58,0x40,0x1,0x20,0x0,0x6,0x49,0x80,0xc2,0x10,0x0,0x0,0xc4,0x0,0x40,0x21,0x80,0x40,0x12,0x0,0x34,0x42,0x0,0x4,0x0,0x0},
        {0x8,0x84,0x0,0x2,0x0,0x80,0x22,0x0,0x0,0x0,0x40,0x0,0x8a,0x10,0x40,0x0,0x80,0x0,0x12,0x14,0x0,0x80,0x80,0x0,0x11,0x4,0x80,0x48,0x22,0x0,0x0,0x40,0x40,0xa,0x12,0x0,0x0,0x40,0x0,0x82,0x14,0x40,0x0,0x80,0x0,0x0,0x11,0x0,0x40,0x10,0x0,0x8,0x44,0x0},
        {0x0,0x0,0x0,0x0,0x0,0x0,0x2,0x40,0x0,0x0,0x0,0x0,0xa,0x8,0x0,0x0,0x80,0x0,0x20,0x52,0x0,0x8,0x2,0x0,0x20,0x8,0x0,0x4,0x1,0x0,0x10,0x4,0x0,0x12,0x81,0x0,0x0,0x40,0x0,0x4,0x14,0x0,0x0,0x0,0x0,0x0,0x90,0x0,0x0,0x0,0x0,0x0,0x0,0x0},
        {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2,0x0,0x0,0x0,0x80,0x0,0x0,0x29,0x0,0x10,0x0,0x0,0x0,0x0,0x0,0x8,0x0,0x0,0x0,0x4,0x0,0x0,0x0,0x0,0x0,0x2,0x0,0x25,0x0,0x0,0x0,0x40,0x0,0x0,0x10,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0}
    };
    /*unsigned char flamme[8][468] = {
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0, 2, 24, 0, 0, 0, 0, 3, 28, 192, 0, 0, 0, 1, 54, 248, 0, 0, 0, 0, 55, 126, 48, 0, 0, 0, 115, 179, 188, 0, 0, 0, 224, 255, 206, 0, 0, 0, 224, 124, 238, 0, 0, 1, 192, 62, 55, 0, 0, 1, 132, 31, 27, 128, 0, 1, 132, 31, 143, 160, 0, 1, 142, 15, 230, 240, 0, 0, 134, 7, 243, 112, 0, 0, 199, 128, 240, 112, 0, 0, 99, 240, 24, 120, 0, 0, 97, 248, 0, 56, 0, 0, 96, 120, 0, 56, 0, 0, 192, 24, 0, 56, 0, 0, 192, 8, 0, 56, 0, 0, 192, 0, 0, 56, 0, 0, 192, 0, 0, 24, 0, 0, 96, 0, 0, 24, 0, 0, 96, 0, 0, 12, 0, 0, 96, 0, 0, 4, 0, 0, 224, 0, 0, 6, 0, 1, 192, 0, 0, 3, 128, 0, 126, 0, 0, 63, 192, 0, 15, 254, 0, 255, 128, 0, 0, 127, 255, 252, 0 },
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 128, 0, 0, 0, 0, 1, 192, 0, 0, 0, 0, 1, 96, 0, 0, 0, 0, 1, 48, 0, 0, 0, 0, 1, 158, 0, 0, 0, 2, 2, 156, 0, 0, 0, 2, 2, 153, 32, 0, 0, 6, 130, 249, 144, 0, 0, 5, 135, 116, 236, 0, 0, 13, 69, 244, 114, 0, 0, 9, 108, 252, 18, 0, 0, 3, 126, 124, 10, 0, 0, 1, 26, 12, 22, 0, 0, 9, 11, 6, 21, 0, 0, 5, 1, 3, 52, 128, 0, 12, 1, 129, 108, 64, 0, 8, 0, 192, 110, 96, 0, 8, 56, 0, 231, 224, 0, 8, 228, 0, 35, 224, 0, 13, 226, 2, 0, 96, 0, 12, 224, 1, 128, 48, 0, 7, 208, 0, 66, 24, 0, 3, 192, 0, 1, 12, 0, 2, 128, 0, 0, 140, 0, 1, 128, 0, 0, 132, 0, 5, 128, 0, 0, 134, 0, 7, 4, 8, 2, 130, 0, 7, 4, 4, 1, 67, 0, 5, 0, 2, 0, 131, 0, 3, 2, 0, 0, 33, 0, 3, 0, 0, 0, 49, 0, 1, 128, 0, 0, 17, 0, 0, 128, 0, 0, 1, 0, 0, 192, 0, 0, 1, 0, 0, 192, 0, 0, 3, 0, 0, 64, 0, 0, 3, 0, 0, 224, 0, 0, 2, 0, 0, 224, 0, 0, 7, 0, 0, 192, 0, 0, 3, 128, 0, 192, 0, 0, 1, 128, 1, 128, 0, 0, 1, 128, 3, 3, 128, 0, 3, 128, 1, 255, 192, 0, 31, 192, 0, 15, 255, 248, 127, 128, 0, 0, 127, 255, 254, 0 },
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 52, 0, 0, 0, 0, 0, 100, 128, 0, 0, 0, 0, 100, 128, 0, 0, 0, 0, 236, 0, 0, 0, 0, 1, 41, 72, 0, 0, 0, 0, 82, 72, 0, 0, 0, 0, 198, 206, 0, 0, 0, 1, 12, 133, 192, 0, 0, 2, 57, 146, 120, 0, 0, 0, 227, 17, 140, 0, 0, 3, 134, 64, 194, 0, 0, 6, 0, 104, 35, 0, 0, 24, 0, 200, 49, 0, 0, 48, 1, 144, 17, 0, 0, 32, 3, 16, 18, 0, 0, 96, 7, 16, 54, 0, 0, 64, 14, 3, 61, 0, 0, 64, 28, 1, 237, 128, 0, 96, 56, 0, 239, 192, 0, 96, 57, 128, 199, 192, 1, 176, 24, 224, 195, 64, 3, 16, 24, 240, 192, 64, 3, 136, 12, 113, 224, 64, 3, 204, 6, 105, 240, 96, 3, 220, 7, 104, 184, 32, 18, 248, 7, 204, 78, 32, 62, 248, 3, 198, 103, 32, 61, 184, 3, 135, 23, 160, 57, 216, 3, 131, 155, 224, 25, 92, 1, 193, 74, 96, 27, 66, 5, 192, 65, 32, 31, 64, 1, 192, 1, 32, 7, 192, 0, 160, 0, 128, 6, 128, 1, 32, 0, 64, 13, 0, 3, 16, 0, 96, 3, 0, 0, 128, 0, 32, 7, 0, 1, 128, 0, 32, 6, 0, 0, 192, 0, 32, 6, 0, 0, 0, 0, 48, 4, 0, 0, 0, 0, 16, 4, 0, 0, 0, 0, 16, 4, 0, 0, 0, 0, 16, 4, 0, 64, 0, 0, 16, 6, 0, 112, 0, 0, 32, 2, 0, 112, 0, 0, 96, 2, 0, 64, 0, 0, 192, 1, 0, 32, 0, 1, 128, 1, 0, 16, 0, 1, 16, 1, 128, 0, 0, 3, 48, 1, 0, 0, 0, 3, 112, 1, 128, 0, 0, 3, 240, 1, 128, 0, 0, 1, 176, 1, 128, 0, 0, 0, 32, 0, 128, 0, 0, 0, 32, 0, 64, 0, 0, 0, 32, 0, 96, 0, 0, 0, 96, 0, 24, 0, 0, 0, 96, 0, 88, 0, 0, 0, 192, 0, 92, 0, 0, 0, 128, 0, 120, 64, 0, 0, 192, 0, 112, 96, 0, 1, 192, 0, 56, 112, 1, 1, 128, 0, 60, 240, 1, 131, 128, 0, 31, 248, 3, 199, 0, 0, 3, 223, 255, 222, 0, 0, 0, 7, 255, 252, 0 },
        { 0, 0, 8, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 120, 0, 0, 0, 0, 0, 240, 0, 0, 0, 0, 1, 176, 0, 0, 0, 0, 1, 241, 0, 0, 0, 0, 1, 233, 128, 0, 0, 0, 1, 181, 224, 0, 0, 0, 0, 178, 176, 0, 0, 0, 0, 153, 24, 0, 0, 0, 0, 24, 152, 0, 0, 0, 0, 56, 26, 30, 0, 0, 0, 112, 27, 57, 0, 0, 0, 96, 59, 249, 0, 0, 0, 64, 125, 159, 0, 0, 0, 192, 54, 14, 0, 0, 0, 192, 51, 156, 64, 0, 0, 224, 17, 248, 32, 0, 1, 160, 0, 254, 96, 0, 1, 128, 0, 71, 224, 0, 19, 128, 0, 1, 224, 0, 7, 192, 0, 143, 192, 4, 6, 192, 0, 30, 0, 13, 6, 64, 0, 28, 0, 15, 34, 32, 0, 24, 0, 31, 51, 32, 0, 248, 0, 27, 63, 16, 0, 252, 0, 29, 31, 48, 1, 252, 0, 14, 62, 48, 1, 222, 0, 6, 62, 56, 1, 199, 0, 0, 108, 12, 2, 96, 0, 0, 108, 2, 6, 16, 0, 0, 36, 1, 0, 12, 0, 0, 32, 0, 0, 14, 0, 0, 96, 0, 0, 3, 0, 0, 96, 0, 0, 0, 192, 0, 96, 0, 0, 0, 96, 0, 96, 0, 0, 0, 32, 0, 112, 0, 0, 0, 16, 1, 56, 0, 0, 0, 16, 3, 30, 0, 0, 0, 24, 7, 143, 128, 0, 0, 8, 15, 255, 192, 0, 0, 8, 12, 255, 192, 0, 0, 8, 76, 7, 64, 0, 14, 24, 76, 1, 0, 0, 31, 144, 20, 0, 128, 0, 63, 240, 52, 0, 64, 0, 63, 240, 52, 0, 0, 0, 63, 224, 58, 0, 0, 0, 30, 192, 27, 0, 0, 0, 29, 0, 157, 128, 0, 0, 12, 0, 245, 128, 0, 0, 12, 0, 228, 128, 0, 0, 12, 0, 65, 128, 0, 0, 6, 0, 99, 0, 0, 0, 2, 0, 58, 0, 0, 0, 1, 0, 14, 0, 0, 0, 0, 128, 26, 0, 0, 0, 0, 192, 48, 0, 0, 0, 0, 192, 120, 0, 14, 128, 0, 208, 112, 0, 156, 0, 0, 208, 112, 4, 248, 0, 0, 240, 208, 12, 112, 0, 0, 248, 208, 30, 0, 0, 4, 104, 232, 110, 3, 192, 12, 216, 96, 63, 135, 240, 12, 16, 112, 255, 254, 127, 24, 48, 63, 254, 252, 14, 50, 96, 31, 255, 24, 23, 243, 192, 3, 190, 48, 15, 227, 128, 0, 31, 224, 15, 131, 128, 0, 15, 192, 7, 207, 128, 0, 3, 0, 7, 255, 128, 0, 0, 0, 3, 243, 0, 0, 0, 0, 1, 224, 0 },
        { 0, 0, 32, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 192, 0, 0, 0, 0, 0, 225, 0, 0, 0, 0, 0, 113, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 35, 128, 0, 0, 0, 0, 66, 128, 0, 0, 0, 0, 2, 160, 0, 0, 0, 0, 6, 224, 0, 0, 0, 0, 14, 96, 0, 0, 0, 0, 30, 196, 0, 0, 0, 0, 31, 196, 0, 0, 0, 0, 63, 134, 0, 0, 0, 0, 63, 6, 0, 0, 0, 0, 116, 11, 6, 0, 0, 0, 102, 11, 15, 0, 0, 0, 99, 201, 14, 0, 0, 0, 96, 233, 14, 0, 0, 0, 112, 61, 44, 0, 0, 0, 55, 15, 108, 0, 0, 0, 51, 134, 104, 0, 0, 0, 49, 198, 23, 0, 0, 1, 33, 194, 12, 128, 0, 3, 32, 193, 24, 208, 0, 38, 32, 65, 25, 240, 0, 117, 48, 0, 157, 224, 0, 82, 176, 0, 78, 192, 0, 114, 216, 0, 254, 0, 0, 119, 92, 1, 254, 0, 0, 53, 172, 3, 46, 0, 0, 45, 166, 6, 36, 0, 0, 44, 59, 6, 34, 0, 0, 76, 25, 135, 98, 0, 0, 6, 0, 129, 194, 0, 0, 35, 0, 0, 1, 0, 0, 33, 0, 0, 1, 0, 0, 32, 128, 0, 1, 0, 0, 48, 192, 0, 1, 0, 0, 48, 192, 0, 0, 128, 0, 112, 128, 0, 0, 128, 0, 89, 192, 0, 4, 192, 0, 79, 64, 0, 7, 96, 0, 68, 0, 0, 3, 240, 0, 64, 0, 0, 1, 248, 0, 128, 0, 0, 1, 248, 8, 128, 0, 0, 1, 104, 16, 192, 0, 0, 241, 8, 48, 192, 0, 1, 255, 8, 52, 96, 0, 1, 255, 8, 44, 48, 0, 1, 254, 24, 56, 60, 0, 0, 248, 16, 16, 56, 0, 0, 236, 48, 0, 30, 0, 0, 231, 224, 4, 12, 0, 0, 107, 192, 6, 14, 0, 0, 120, 0, 3, 15, 28, 0, 60, 0, 3, 12, 63, 0, 54, 0, 3, 158, 243, 128, 51, 128, 2, 159, 128, 192, 177, 192, 6, 239, 0, 0, 232, 96, 6, 192, 0, 1, 100, 96, 4, 4, 0, 2, 0, 32, 12, 3, 0, 0, 64, 96, 8, 3, 216, 0, 68, 96, 24, 3, 252, 0, 248, 224, 28, 1, 246, 1, 248, 240, 62, 3, 255, 3, 240, 248, 56, 11, 255, 255, 193, 248, 60, 23, 159, 255, 103, 184, 55, 111, 127, 254, 255, 48, 59, 191, 255, 231, 252, 112, 28, 127, 227, 255, 255, 224, 31, 254, 0, 127, 255, 192, 15, 248, 0, 63, 255, 0, 7, 224, 0, 15, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
        { 0, 0, 32, 0, 0, 0, 0, 0, 97, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 3, 128, 0, 0, 0, 0, 3, 128, 0, 0, 0, 0, 3, 160, 0, 0, 0, 0, 3, 168, 0, 0, 0, 0, 1, 152, 0, 0, 0, 0, 1, 28, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 2, 60, 0, 0, 0, 0, 2, 124, 0, 0, 0, 0, 2, 120, 0, 0, 0, 0, 6, 240, 4, 0, 0, 0, 7, 240, 4, 0, 0, 0, 15, 240, 12, 0, 0, 0, 15, 224, 28, 0, 0, 0, 31, 224, 28, 0, 0, 0, 59, 224, 12, 0, 0, 0, 51, 208, 28, 0, 0, 0, 99, 152, 20, 0, 0, 32, 99, 140, 50, 0, 0, 34, 227, 142, 122, 0, 0, 50, 193, 206, 127, 0, 0, 50, 193, 255, 111, 64, 0, 50, 192, 251, 47, 128, 0, 35, 96, 3, 7, 0, 0, 3, 224, 3, 0, 0, 0, 6, 240, 2, 0, 0, 0, 5, 56, 6, 0, 0, 0, 4, 152, 14, 0, 0, 0, 6, 152, 60, 128, 0, 0, 5, 128, 60, 130, 0, 0, 6, 0, 109, 130, 0, 0, 3, 192, 111, 198, 0, 0, 33, 224, 79, 199, 0, 0, 64, 112, 15, 103, 0, 0, 129, 62, 6, 109, 0, 0, 129, 52, 0, 253, 0, 1, 193, 112, 0, 251, 0, 1, 193, 240, 0, 195, 0, 1, 227, 224, 0, 7, 0, 9, 254, 224, 0, 6, 64, 9, 188, 192, 0, 14, 64, 25, 192, 0, 0, 28, 96, 48, 224, 0, 0, 56, 112, 56, 240, 208, 0, 114, 208, 24, 124, 224, 0, 99, 144, 0, 62, 192, 0, 97, 160, 0, 63, 0, 0, 115, 240, 0, 124, 0, 0, 62, 128, 0, 22, 0, 0, 29, 192, 0, 120, 0, 0, 1, 192, 0, 238, 15, 1, 1, 128, 1, 207, 223, 128, 131, 0, 1, 203, 159, 192, 3, 0, 3, 200, 63, 192, 6, 0, 3, 196, 127, 192, 12, 0, 3, 231, 255, 240, 30, 0, 1, 241, 249, 252, 62, 0, 0, 255, 255, 255, 252, 0, 2, 127, 255, 255, 240, 0, 1, 255, 255, 243, 192, 0, 1, 255, 239, 192, 0, 0, 0, 255, 224, 0, 0, 0, 0, 62, 224, 0, 0, 0, 0, 1, 224, 0, 0, 0, 0, 3, 192, 0, 0, 0, 0, 15, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
        { 0, 0, 0, 64, 0, 0, 0, 0, 0, 96, 0, 0, 0, 0, 1, 32, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 7, 128, 0, 0, 0, 0, 3, 128, 32, 0, 0, 0, 1, 200, 16, 0, 0, 0, 0, 204, 0, 0, 0, 0, 0, 228, 64, 0, 0, 0, 1, 230, 32, 0, 0, 0, 1, 238, 96, 0, 0, 0, 3, 126, 104, 0, 0, 0, 134, 222, 104, 0, 0, 0, 78, 204, 48, 0, 0, 0, 76, 96, 0, 0, 0, 0, 206, 96, 0, 0, 0, 1, 199, 192, 0, 0, 0, 3, 131, 129, 0, 0, 0, 3, 196, 17, 128, 0, 0, 3, 226, 16, 128, 0, 0, 1, 227, 25, 0, 0, 0, 0, 227, 137, 160, 0, 0, 0, 71, 155, 160, 0, 0, 4, 239, 159, 160, 0, 0, 4, 254, 207, 224, 0, 0, 4, 125, 207, 224, 0, 0, 6, 15, 223, 196, 0, 0, 6, 7, 255, 132, 0, 0, 14, 7, 199, 212, 0, 0, 12, 23, 3, 220, 0, 0, 14, 30, 97, 220, 0, 0, 15, 222, 249, 200, 0, 0, 7, 255, 255, 192, 0, 0, 1, 255, 255, 192, 0, 0, 32, 247, 255, 232, 0, 0, 37, 223, 255, 248, 0, 0, 55, 159, 255, 248, 0, 0, 31, 63, 255, 240, 0, 0, 15, 255, 255, 112, 0, 0, 3, 255, 188, 224, 0, 0, 3, 255, 79, 192, 0, 0, 3, 254, 192, 0, 0, 0, 3, 253, 128, 0, 0, 0, 1, 248, 0, 0, 0, 0, 0, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
        { 0, 0, 0, 2, 0, 0, 0, 0, 4, 10, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 4, 12, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 0, 96, 0, 0, 0, 0, 0, 120, 0, 0, 0, 0, 3, 60, 0, 0, 0, 0, 15, 158, 0, 0, 0, 0, 31, 47, 0, 0, 0, 0, 62, 47, 0, 0, 0, 0, 188, 54, 0, 0, 0, 0, 188, 56, 0, 0, 0, 0, 216, 24, 0, 0, 0, 0, 228, 0, 0, 0, 0, 0, 248, 0, 0, 0, 0, 0, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
    };*/
    const unsigned char time[]={0xfd, 0xa0, 0xbf, 0xfd, 0xb1, 0xbf, 0x30, 0x3b, 0xb1, 0x31, 0xb5, 0xbd, 0x31, 0xb1, 0xb1, 0x31, 0xb1, 0xbf, 0x31, 0xb1, 0xbf};
    const unsigned char best[]={0x0, 0x0, 0x0, 0x7f, 0x79, 0xf7, 0xbf, 0x7f, 0x7d, 0xf7, 0xbf, 0x7f, 0x6d, 0x86, 0xc, 0x7f, 0x79, 0xe3, 0xc, 0x7f, 0x6d, 0x81, 0x8c, 0x7f, 0x7d, 0xf7, 0x8c, 0x7f, 0x79, 0xf7, 0x8c, 0x7f, 0x0, 0x0, 0x0, 0x7f};
    const unsigned char succes_fleche_droite[]={0x1f, 0x80, 0x0, 0xf, 0x3f, 0xe0, 0x0, 0xf, 0x70, 0x70, 0x0, 0xf, 0x67, 0x98, 0x0, 0xf, 0xcf, 0xcc, 0x0, 0xf, 0xdc, 0x66, 0x0, 0xf, 0xd8, 0x33, 0x0, 0xf, 0xd8, 0x19, 0x80, 0xf, 0xd8, 0xc, 0xc0, 0xf, 0xd8, 0x6, 0x60, 0xf, 0xd8, 0x3, 0x30, 0xf, 0xd8, 0x1, 0x98, 0xf, 0xd8, 0x0, 0xcc, 0xf, 0xd8, 0x0, 0x66, 0xf, 0xd8, 0x0, 0x33, 0xf, 0xd8, 0x0, 0x19, 0x8f, 0xd8, 0x0, 0xc, 0xcf, 0xd8, 0x0, 0x6, 0x6f, 0xd8, 0x0, 0x3, 0x3f, 0xd8, 0x0, 0x1, 0x1f, 0xd8, 0x0, 0x3, 0x2f, 0xd8, 0x0, 0x6, 0x4f, 0xd8, 0x0, 0xc, 0x8f, 0xd8, 0x0, 0x19, 0xf, 0xd8, 0x0, 0x32, 0xf, 0xd8, 0x0, 0x64, 0xf, 0xd8, 0x0, 0xc8, 0xf, 0xd8, 0x1, 0x90, 0xf, 0xd8, 0x3, 0x20, 0xf, 0xd8, 0x6, 0x40, 0xf, 0xd8, 0xc, 0x80, 0xf, 0xd8, 0x19, 0x0, 0xf, 0xd8, 0x32, 0x0, 0xf, 0xd8, 0x64, 0x0, 0xf, 0x4f, 0xc8, 0x0, 0xf, 0x47, 0x90, 0x0, 0xf, 0x20, 0x60, 0x0, 0xf, 0x1f, 0x80, 0x0, 0xf};
    const unsigned char succes_fleche_droite_negatif[]={0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf0, 0x7f, 0xff, 0xff, 0xe7, 0x9f, 0xff, 0xff, 0xcf, 0xcf, 0xff, 0xff, 0xdc, 0x67, 0xff, 0xff, 0xd8, 0x33, 0xff, 0xff, 0xd8, 0x19, 0xff, 0xff, 0xd8, 0xc, 0xff, 0xff, 0xd8, 0x6, 0x7f, 0xff, 0xd8, 0x3, 0x3f, 0xff, 0xd8, 0x1, 0x9f, 0xff, 0xd8, 0x0, 0xcf, 0xff, 0xd8, 0x0, 0x67, 0xff, 0xd8, 0x0, 0x33, 0xff, 0xd8, 0x0, 0x19, 0xff, 0xd8, 0x0, 0xc, 0xff, 0xd8, 0x0, 0x6, 0x7f, 0xd8, 0x0, 0x1, 0x3f, 0xd8, 0x0, 0x1, 0x1f, 0xd8, 0x0, 0x3, 0x3f, 0xd8, 0x0, 0x6, 0x7f, 0xd8, 0x0, 0xc, 0xff, 0xd8, 0x0, 0x19, 0xff, 0xd8, 0x0, 0x33, 0xff, 0xd8, 0x0, 0x67, 0xff, 0xd8, 0x0, 0xcf, 0xff, 0xd8, 0x1, 0x9f, 0xff, 0xd8, 0x3, 0x3f, 0xff, 0xd8, 0x6, 0x7f, 0xff, 0xd8, 0xc, 0xff, 0xff, 0xd8, 0x19, 0xff, 0xff, 0xd8, 0x33, 0xff, 0xff, 0xd8, 0x67, 0xff, 0xff, 0xcf, 0xcf, 0xff, 0xff, 0xc7, 0x9f, 0xff, 0xff, 0xe0, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
    const unsigned char succes_fleche_gauche[]={0x0, 0x0, 0x1f, 0x8f, 0x0, 0x0, 0x60, 0x4f, 0x0, 0x0, 0x9e, 0x2f, 0x0, 0x1, 0x3f, 0x2f, 0x0, 0x2, 0x61, 0xbf, 0x0, 0x4, 0xc1, 0xbf, 0x0, 0x9, 0x81, 0xbf, 0x0, 0x13, 0x1, 0xbf, 0x0, 0x26, 0x1, 0xbf, 0x0, 0x4c, 0x1, 0xbf, 0x0, 0x98, 0x1, 0xbf, 0x1, 0x30, 0x1, 0xbf, 0x2, 0x60, 0x1, 0xbf, 0x4, 0xc0, 0x1, 0xbf, 0x9, 0x80, 0x1, 0xbf, 0x13, 0x0, 0x1, 0xbf, 0x26, 0x0, 0x1, 0xbf, 0x4c, 0x0, 0x1, 0xbf, 0x88, 0x0, 0x1, 0xbf, 0xcc, 0x0, 0x1, 0xbf, 0x66, 0x0, 0x1, 0xbf, 0x33, 0x0, 0x1, 0xbf, 0x19, 0x80, 0x1, 0xbf, 0xc, 0xc0, 0x1, 0xbf, 0x6, 0x60, 0x1, 0xbf, 0x3, 0x30, 0x1, 0xbf, 0x1, 0x98, 0x1, 0xbf, 0x0, 0xcc, 0x1, 0xbf, 0x0, 0x66, 0x1, 0xbf, 0x0, 0x33, 0x1, 0xbf, 0x0, 0x19, 0x81, 0xbf, 0x0, 0xc, 0xc1, 0xbf, 0x0, 0x6, 0x63, 0xbf, 0x0, 0x3, 0x3f, 0x3f, 0x0, 0x1, 0x9e, 0x6f, 0x0, 0x0, 0xe0, 0xef, 0x0, 0x0, 0x7f, 0xcf, 0x0, 0x0, 0x1f, 0x8f};
    const unsigned char succes_fleche_gauche_negatif[]={0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe0, 0x7f, 0xff, 0xff, 0x9e, 0x3f, 0xff, 0xff, 0x3f, 0x3f, 0xff, 0xfe, 0x61, 0xbf, 0xff, 0xfc, 0xc1, 0xbf, 0xff, 0xf9, 0x81, 0xbf, 0xff, 0xf3, 0x1, 0xbf, 0xff, 0xe6, 0x1, 0xbf, 0xff, 0xcc, 0x1, 0xbf, 0xff, 0x98, 0x1, 0xbf, 0xff, 0x30, 0x1, 0xbf, 0xfe, 0x60, 0x1, 0xbf, 0xfc, 0xc0, 0x1, 0xbf, 0xf9, 0x80, 0x1, 0xbf, 0xf3, 0x0, 0x1, 0xbf, 0xe6, 0x0, 0x1, 0xbf, 0xcc, 0x0, 0x1, 0xbf, 0x88, 0x0, 0x1, 0xbf, 0xcc, 0x0, 0x1, 0xbf, 0xe6, 0x0, 0x1, 0xbf, 0xf3, 0x0, 0x1, 0xbf, 0xf9, 0x80, 0x1, 0xbf, 0xfc, 0xc0, 0x1, 0xbf, 0xfe, 0x60, 0x1, 0xbf, 0xff, 0x30, 0x1, 0xbf, 0xff, 0x98, 0x1, 0xbf, 0xff, 0xcc, 0x1, 0xbf, 0xff, 0xe6, 0x1, 0xbf, 0xff, 0xf3, 0x1, 0xbf, 0xff, 0xf9, 0x81, 0xbf, 0xff, 0xfc, 0xc1, 0xbf, 0xff, 0xfe, 0x63, 0xbf, 0xff, 0xff, 0x3f, 0x3f, 0xff, 0xff, 0x9e, 0x7f, 0xff, 0xff, 0xe0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
    int place=0, pieces=0, un;
    int obstacle1[4]={39, 10, 7, 7}, obstacle2[4]={71, 8, 8, 7}, obstacle3[4]={42, 45, 4, 7}, obstacle4[4]={72, 47, 14, 3}, bouche_trou[4];
    /*obstacle[0]=x
    obstacle[1]=y
    obstacle[2]=taille_x
    obstacle[3]=taille_y
    */

    while(1){
        un=0;
        srand(RTC_getTicks());
        do{
            disposition=rand()%24+1;
        }while(direc<1 || direc>24);       //boucle pour eviter certaines erreurs que j'ai pu rencontrer lors de mon falldown
        do{
            direc=rand()%24+1;
        }while(direc<1 || direc>24);

        carre_x=62;
        carre_y=30;
        vitesse_obs1_x=1;
        vitesse_obs1_y=1;
        vitesse_obs2_x=-1;
        vitesse_obs2_y=1;
        vitesse_obs3_x=1;
        vitesse_obs3_y=-1;
        vitesse_obs4_x=-1;
        vitesse_obs4_y=-1;

        do{
            obstacle1[0]=39;
            obstacle1[1]=10;
            obstacle1[2]=7;
            obstacle1[3]=7;
            obstacle2[0]=71;
            obstacle2[1]=8;
            obstacle2[2]=8;
            obstacle2[3]=7;
            obstacle3[0]=42;
            obstacle3[1]=45;
            obstacle3[2]=4;
            obstacle3[3]=7;
            obstacle4[0]=72;
            obstacle4[1]=47;
            obstacle4[2]=14;
            obstacle4[3]=3;

            if(IsKeyDown(KEY_CHAR_4) && IsKeyDown(KEY_CHAR_2)) quardeux=2;        //vous n'etes pas sense voir ca : succes sucret ^^
            if(quardeux && IsKeyDown(KEY_CTRL_EXE)){
                    while(IsKeyDown(KEY_CTRL_EXE));
                    quardeux--;
            }

            switch (disposition){       //dsl je sais c long et chiant mais jai pas trouve moyen de faire plus court
                case 1 :    //1234
                    break;
                case 2 :    //1243
                    transfert(bouche_trou, obstacle3, 2);
                    transfert(obstacle3, obstacle4, 2);
                    transfert(obstacle4, bouche_trou, 2);
                    break;
                case 3 :    //1324
                    transfert(bouche_trou, obstacle2, 2);
                    transfert(obstacle2, obstacle3, 2);
                    transfert(obstacle3, bouche_trou, 2);
                    break;
                case 4 :    //1342
                    transfert(bouche_trou, obstacle2, 2);
                    transfert(obstacle2, obstacle3, 2);
                    transfert(obstacle3, obstacle4, 2);
                    transfert(obstacle4, bouche_trou, 2);
                    break;
                case 5 :    //1432
                    transfert(bouche_trou, obstacle2, 2);
                    transfert(obstacle2, obstacle4, 2);
                    transfert(obstacle4, bouche_trou, 2);
                    break;
                case 6 :    //1423
                    transfert(bouche_trou, obstacle2, 2);
                    transfert(obstacle2, obstacle4, 2);
                    transfert(obstacle4, obstacle3, 2);
                    transfert(obstacle3, bouche_trou, 2);
                    break;
                case 7 :    //2134
                    transfert(bouche_trou, obstacle1, 2);
                    transfert(obstacle1, obstacle2, 2);
                    transfert(obstacle2, bouche_trou, 2);
                    break;
                case 8 :    //2143
                    transfert(bouche_trou, obstacle1, 2);
                    transfert(obstacle1, obstacle2, 2);
                    transfert(obstacle2, bouche_trou, 2);
                    transfert(bouche_trou, obstacle3, 2);
                    transfert(obstacle3, obstacle4, 2);
                    transfert(obstacle4, bouche_trou, 2);
                    break;
                case 9 :    //2314
                    transfert(bouche_trou, obstacle1, 2);
                    transfert(obstacle1, obstacle2, 2);
                    transfert(obstacle2, obstacle3, 2);
                    transfert(obstacle3, bouche_trou, 2);
                    break;
                case 10 :    //2341
                    transfert(bouche_trou, obstacle1, 2);
                    transfert(obstacle1, obstacle2, 2);
                    transfert(obstacle2, obstacle3, 2);
                    transfert(obstacle3, obstacle4, 2);
                    transfert(obstacle4, bouche_trou, 2);
                    break;
                case 11 :    //2431
                    transfert(bouche_trou, obstacle1, 2);
                    transfert(obstacle1, obstacle2, 2);
                    transfert(obstacle2, obstacle4, 2);
                    transfert(obstacle4, bouche_trou, 2);
                    break;
                case 12 :    //2413
                    transfert(bouche_trou, obstacle1, 2);
                    transfert(obstacle1, obstacle2, 2);
                    transfert(obstacle2, obstacle4, 2);
                    transfert(obstacle4, obstacle3, 2);
                    transfert(obstacle3, bouche_trou, 2);
                    break;
                case 13:    //3142
                    transfert(bouche_trou, obstacle1, 2);
                    transfert(obstacle1, obstacle3, 2);
                    transfert(obstacle3, obstacle4, 2);
                    transfert(obstacle4, obstacle2, 2);
                    transfert(obstacle2, bouche_trou, 2);
                    break;
                case 14:    //3124
                    transfert(bouche_trou, obstacle1, 2);
                    transfert(obstacle1, obstacle3, 2);
                    transfert(obstacle3, obstacle2, 2);
                    transfert(obstacle2, bouche_trou, 2);
                    break;
                case 15 :    //3241
                    transfert(bouche_trou, obstacle1, 2);
                    transfert(obstacle1, obstacle3, 2);
                    transfert(obstacle3, obstacle4, 2);
                    transfert(obstacle4, bouche_trou, 2);
                    break;
                case 16 :    //3214
                    transfert(bouche_trou, obstacle1, 2);
                    transfert(obstacle1, obstacle3, 2);
                    transfert(obstacle3, bouche_trou, 2);
                    break;
                case 17 :    //3412
                    transfert(bouche_trou, obstacle1, 2);
                    transfert(obstacle1, obstacle3, 2);
                    transfert(obstacle3, bouche_trou, 2);
                    transfert(bouche_trou, obstacle2, 2);
                    transfert(obstacle2, obstacle4, 2);
                    transfert(obstacle4, bouche_trou, 2);
                    break;
                case 18 :    //3421
                    transfert(bouche_trou, obstacle1, 2);
                    transfert(obstacle1, obstacle3, 2);
                    transfert(obstacle3, obstacle2, 2);
                    transfert(obstacle2, obstacle4, 2);
                    transfert(obstacle4, bouche_trou, 2);
                    break;
                case 19 :    //4123
                    transfert(bouche_trou, obstacle2, 2);
                    transfert(obstacle2, obstacle1, 2);
                    transfert(obstacle1, obstacle4, 2);
                    transfert(obstacle4, obstacle3, 2);
                    transfert(obstacle3, bouche_trou, 2);
                    break;
                case 20 :    //4132
                    transfert(bouche_trou, obstacle1, 2);
                    transfert(obstacle1, obstacle4, 2);
                    transfert(obstacle4, obstacle2, 2);
                    transfert(obstacle2, bouche_trou, 2);
                    break;
                case 21 :    //4213
                    transfert(bouche_trou, obstacle1, 2);
                    transfert(obstacle1, obstacle4, 2);
                    transfert(obstacle4, obstacle3, 2);
                    transfert(obstacle3, bouche_trou, 2);
                    break;
                case 22 :    //4231
                    transfert(bouche_trou, obstacle1, 2);
                    transfert(obstacle1, obstacle4, 2);
                    transfert(obstacle4, bouche_trou, 2);
                    break;
                case 23 :    //4312
                    transfert(bouche_trou, obstacle1, 2);
                    transfert(obstacle1, obstacle4, 2);
                    transfert(obstacle4, obstacle2, 2);
                    transfert(obstacle2, obstacle3, 2);
                    transfert(obstacle3, bouche_trou, 2);
                    break;
                case 24 :    //4321
                    transfert(bouche_trou, obstacle1, 2);
                    transfert(obstacle1, obstacle4, 2);
                    transfert(obstacle4, bouche_trou, 2);
                    transfert(bouche_trou, obstacle2, 2);
                    transfert(obstacle2, obstacle3, 2);
                    transfert(obstacle3, bouche_trou, 2);
                    break;
            }
            switch (direc){       //dsl je sais c long et chiant mais jai pas trouve moyen de faire plus court
                case 1 :    //1234
                    break;
                case 2 :    //1243
                    transfert(bouche_trou, obstacle3, 4);
                    transfert(obstacle3, obstacle4, 4);
                    transfert(obstacle4, bouche_trou, 4);
                    break;
                case 3 :    //1324
                    transfert(bouche_trou, obstacle2, 4);
                    transfert(obstacle2, obstacle3, 4);
                    transfert(obstacle3, bouche_trou, 4);
                    break;
                case 4 :    //1342
                    transfert(bouche_trou, obstacle2, 4);
                    transfert(obstacle2, obstacle3, 4);
                    transfert(obstacle3, obstacle4, 4);
                    transfert(obstacle4, bouche_trou, 4);
                    break;
                case 5 :    //1432
                    transfert(bouche_trou, obstacle2, 4);
                    transfert(obstacle2, obstacle4, 4);
                    transfert(obstacle4, bouche_trou, 4);
                    break;
                case 6 :    //1423
                    transfert(bouche_trou, obstacle2, 4);
                    transfert(obstacle2, obstacle4, 4);
                    transfert(obstacle4, obstacle3, 4);
                    transfert(obstacle3, bouche_trou, 4);
                    break;
                case 7 :    //2134
                    transfert(bouche_trou, obstacle1, 4);
                    transfert(obstacle1, obstacle2, 4);
                    transfert(obstacle2, bouche_trou, 4);
                    break;
                case 8 :    //2143
                    transfert(bouche_trou, obstacle1, 4);
                    transfert(obstacle1, obstacle2, 4);
                    transfert(obstacle2, bouche_trou, 4);
                    transfert(bouche_trou, obstacle3, 4);
                    transfert(obstacle3, obstacle4, 4);
                    transfert(obstacle4, bouche_trou, 4);
                    break;
                case 9 :    //2314
                    transfert(bouche_trou, obstacle1, 4);
                    transfert(obstacle1, obstacle2, 4);
                    transfert(obstacle2, obstacle3, 4);
                    transfert(obstacle3, bouche_trou, 4);
                    break;
                case 10 :    //2341
                    transfert(bouche_trou, obstacle1, 4);
                    transfert(obstacle1, obstacle2, 4);
                    transfert(obstacle2, obstacle3, 4);
                    transfert(obstacle3, obstacle4, 4);
                    transfert(obstacle4, bouche_trou, 4);
                    break;
                case 11 :    //2431
                    transfert(bouche_trou, obstacle1, 4);
                    transfert(obstacle1, obstacle2, 4);
                    transfert(obstacle2, obstacle4, 4);
                    transfert(obstacle4, bouche_trou, 4);
                    break;
                case 12 :    //2413
                    transfert(bouche_trou, obstacle1, 4);
                    transfert(obstacle1, obstacle2, 4);
                    transfert(obstacle2, obstacle4, 4);
                    transfert(obstacle4, obstacle3, 4);
                    transfert(obstacle3, bouche_trou, 4);
                    break;
                case 13:    //3142
                    transfert(bouche_trou, obstacle1, 4);
                    transfert(obstacle1, obstacle3, 4);
                    transfert(obstacle3, obstacle4, 4);
                    transfert(obstacle4, obstacle2, 4);
                    transfert(obstacle2, bouche_trou, 4);
                    break;
                case 14:    //3124
                    transfert(bouche_trou, obstacle1, 4);
                    transfert(obstacle1, obstacle3, 4);
                    transfert(obstacle3, obstacle2, 4);
                    transfert(obstacle2, bouche_trou, 4);
                    break;
                case 15 :    //3241
                    transfert(bouche_trou, obstacle1, 4);
                    transfert(obstacle1, obstacle3, 4);
                    transfert(obstacle3, obstacle4, 4);
                    transfert(obstacle4, bouche_trou, 4);
                    break;
                case 16 :    //3214
                    transfert(bouche_trou, obstacle1, 4);
                    transfert(obstacle1, obstacle3, 4);
                    transfert(obstacle3, bouche_trou, 4);
                    break;
                case 17 :    //3412
                    transfert(bouche_trou, obstacle1, 4);
                    transfert(obstacle1, obstacle3, 4);
                    transfert(obstacle3, bouche_trou, 4);
                    transfert(bouche_trou, obstacle2, 4);
                    transfert(obstacle2, obstacle4, 4);
                    transfert(obstacle4, bouche_trou, 4);
                    break;
                case 18 :    //3421
                    transfert(bouche_trou, obstacle1, 4);
                    transfert(obstacle1, obstacle3, 4);
                    transfert(obstacle3, obstacle2, 4);
                    transfert(obstacle2, obstacle4, 4);
                    transfert(obstacle4, bouche_trou, 4);
                    break;
                case 19 :    //4123
                    transfert(bouche_trou, obstacle2, 4);
                    transfert(obstacle2, obstacle1, 4);
                    transfert(obstacle1, obstacle4, 4);
                    transfert(obstacle4, obstacle3, 4);
                    transfert(obstacle3, bouche_trou, 4);
                    break;
                case 20 :    //4132
                    transfert(bouche_trou, obstacle1, 4);
                    transfert(obstacle1, obstacle4, 4);
                    transfert(obstacle4, obstacle2, 4);
                    transfert(obstacle2, bouche_trou, 4);
                    break;
                case 21 :    //4213
                    transfert(bouche_trou, obstacle1, 4);
                    transfert(obstacle1, obstacle4, 4);
                    transfert(obstacle4, obstacle3, 4);
                    transfert(obstacle3, bouche_trou, 4);
                    break;
                case 22 :    //4231
                    transfert(bouche_trou, obstacle1, 4);
                    transfert(obstacle1, obstacle4, 4);
                    transfert(obstacle4, bouche_trou, 4);
                    break;
                case 23 :    //4312
                    transfert(bouche_trou, obstacle1, 4);
                    transfert(obstacle1, obstacle4, 4);
                    transfert(obstacle4, obstacle2, 4);
                    transfert(obstacle2, obstacle3, 4);
                    transfert(obstacle3, bouche_trou, 4);
                    break;
                case 24 :    //4321
                    transfert(bouche_trou, obstacle1, 4);
                    transfert(obstacle1, obstacle4, 4);
                    transfert(obstacle4, bouche_trou, 4);
                    transfert(bouche_trou, obstacle2, 4);
                    transfert(obstacle2, obstacle3, 4);
                    transfert(obstacle3, bouche_trou, 4);
                    break;
            }

            ML_clear_vram();
            stop=0;
            compteur_xor=0;
            afficher_obstacles(obstacle1, obstacle2, obstacle3, obstacle4);
            ML_rectangle(carre_x, carre_y, carre_x+5, carre_y+5, 1, 1, 0);
            direction(obstacle1, vitesse_obs1_x, vitesse_obs1_y, 1);
            direction(obstacle2, vitesse_obs2_x, vitesse_obs2_y, 1);
            direction(obstacle3, vitesse_obs3_x, vitesse_obs3_y, 1);
            direction(obstacle4, vitesse_obs4_x, vitesse_obs4_y, 1);
            if(!quardeux){
                PrintMini(5, 32, (const unsigned char *)":", 1);
                PrintMini(16, 32, (const unsigned char *)":", 1);
                PrintVariable(1, 32, min, 1);
                PrintVariable(8, 32, sec, 1);
                PrintVariable(19, 32, cent_sec, 1);
                if(recording[0]){
                    record= (float) recording[0]/100;
                    min_rec=(int)(record/60);
                    record-=min_rec*60;
                    sec_rec=(int)(record);
                    cent_sec_rec=record-sec_rec;
                }
                ML_rectangle(100, 0, 128, 64, 1, 1, 1);
                PrintMini(105, 32, (const unsigned char *)":", 2);
                PrintMini(116, 32, (const unsigned char *)":", 2);
                PrintVariable(101, 32, min_rec, 2);
                PrintVariable(108, 32, sec_rec, 2);
                PrintVariable(119, 32, cent_sec_rec*100, 2);
                ML_bmp_xor(time, 2, 20, 23, 7);
                ML_bmp_xor(best, 102, 19, 25, 9);
            }
            else{
                if(!un) recording[24]++;    //pour ne pas augmenter cette stats a linfini
                un++;
                if(!recording[8]){
                    ML_clear_vram();
                    PrintMini(0, 0,  (const unsigned char *)" Bravo ! Tu as trouve un succes ", 1);
                    PrintMini(0, 8,  (const unsigned char *)"   secret. Tu peux a present    ", 1);
                    PrintMini(0, 16, (const unsigned char *)"   changer la disposition des   ", 1);
                    PrintMini(0, 24, (const unsigned char *)"obstacles a ta guise. Change la ", 1);
                    PrintMini(0, 32, (const unsigned char *)"avec les fleches directionnelles", 1);
                    PrintMini(0, 40, (const unsigned char *)"puis appuies sur EXE pour valider", 1);
                    ML_display_vram();
                    while(IsKeyUp(KEY_CTRL_EXE));
                    while(IsKeyDown(KEY_CTRL_EXE));
                    deverouillage[0]=8;
                    succes(recording, deverouillage);
                    memory_save(FILEPATH, recording, TAILLE);  //on sauvegarde
                }
                if(un>1){     //pour que ca laisse une frame afin de tout reafficher
                    if(quardeux==2){
                        PrintMini(0, 0, (const unsigned char *)"dispo n", 1);
                        PrintVariable(10, 8, disposition, 1);
                    }
                    else {
                        PrintMini(0, 0, (const unsigned char *)"direc n", 1);
                        PrintVariable(10, 8, direc, 1);
                    }
                    if(IsKeyDown(KEY_CTRL_RIGHT)){
                        ML_bmp_or(succes_fleche_droite_negatif, 100, 13, 28, 38);    //couleurs inversees suivant si on appuie ou pas
                        ML_rectangle(100, 13, 128, 50, 0, 0, 2);
                        if(disposition<24 && quardeux==2)   disposition++;
                        if(direc<24 && quardeux==1)   direc++;
                    }
                    else    ML_bmp_or(succes_fleche_droite, 100, 13, 28, 38);
                    if(IsKeyDown(KEY_CTRL_LEFT)){
                        ML_bmp_or(succes_fleche_gauche_negatif, 0, 13, 28, 38);
                        ML_rectangle(0, 13, 26, 50, 0, 0, 2);
                        if(disposition>1 && quardeux==2)   disposition--;
                        if(direc>1 && quardeux==1)   direc--;
                    }
                    else    ML_bmp_or(succes_fleche_gauche, 0, 13, 28, 38);
                    ML_display_vram();
                    while(IsKeyDown(KEY_CTRL_RIGHT) || IsKeyDown(KEY_CTRL_LEFT)) Sleep(2);

                }
            }
            ML_display_vram();

        }while((!IsKeyDown(KEY_CTRL_UP) && !IsKeyDown(KEY_CTRL_RIGHT) && !IsKeyDown(KEY_CTRL_DOWN) && !IsKeyDown(KEY_CTRL_LEFT) && IsKeyUp(KEY_CTRL_MENU)) || quardeux);     //rien ne bouge tant qu'on a touch  aucune touche
        if(IsKeyDown(KEY_CTRL_MENU)) break;

        temps_reference = RTC_getTicks();
        sec=0;
        min=0;
        cent_sec=0;
        recording[15]++;
        temps_pause_partie=0;

        while(!stop){
            record=(float) recording[0]/100;

            if(IsKeyDown(KEY_CTRL_SHIFT))   shift=2;    //acclration ou non suivant si shift est press
            else    shift=1;

            temps_pause_ecoule=0.0;
            if(IsKeyDown(KEY_CTRL_F1)){                                        //         >>>PAUSE<<<
                recording[19]++;
                temps_pause_reference=RTC_getTicks();                          //on dfini le moment ou a commenc la pause
                ML_rectangle(0, 0, 128, 64, 1, 2, 2);                          //on inverse les couleurs
                direction(obstacle1, vitesse_obs1_x, vitesse_obs1_y, 0);
                direction(obstacle2, vitesse_obs2_x, vitesse_obs2_y, 0);
                direction(obstacle3, vitesse_obs3_x, vitesse_obs3_y, 0);
                direction(obstacle4, vitesse_obs4_x, vitesse_obs4_y, 0);
                ML_display_vram();
                while(IsKeyDown(KEY_CTRL_F1));                                 //tant que F1 est appuy
                while(IsKeyUp(KEY_CTRL_F1)){                                   //tant que F1 n'est pas press
                    Sleep(2);                                                  //un petit sleep pour economiser les piles
                    if(IsKeyDown(KEY_CTRL_MENU)){
                        stop=1;
                        temps_pause_ecoule = (RTC_getTicks() - temps_pause_reference) / 1.28/100;
                        temps_pause_partie+=temps_pause_ecoule;                //ici aussi on abandonne les secondes pour ne pas depasser la limite du int
                        recording[20]++;
                        break;                                                 //si menu est press, on quitte le jeu mais on sauvegarde quand meme
                    }
                }
                while(IsKeyDown(KEY_CTRL_F1));                                 //tant que F1 est appuy
                ML_rectangle(0, 0, 128, 64, 1, 2, 2);                          //on rinverse les couleurs
                temps_pause_ecoule = (RTC_getTicks() - temps_pause_reference) / 1.28/100;
                temps_pause_partie+=temps_pause_ecoule;
                temps_reference+=temps_pause_ecoule*128;       //afin de pas rajouter quelques centiemes de secondes supp a chaque pause
            }

            if(!compteur_xor || compteur_xor==2 || compteur_xor==4 || compteur_xor==6 || compteur_xor==8){
                ML_rectangle(100, 0, 128, 64, 1, 1, 1);    //couleur normale si le record n'a pas t battu ou durant le clignotement
                //ML_bmp_xor(best, 102, 19, 25, 9);
            }
            else{
                ML_rectangle(100, 0, 128, 64, 1, 0, 0);     //couleur inverse si le record a t battu
                //ML_bmp_or(best, 102, 19, 25, 9);
            }
            ML_bmp_xor(best, 102, 19, 25, 9);
            ML_bmp_or(time, 2, 20, 23, 7);

            if(IsKeyDown(KEY_CTRL_UP))      carre_y-=2*shift; //dplacement du carr selon les touches
            if(IsKeyDown(KEY_CTRL_RIGHT))   carre_x+=2*shift;
            if(IsKeyDown(KEY_CTRL_DOWN))    carre_y+=2*shift;
            if(IsKeyDown(KEY_CTRL_LEFT))    carre_x-=2*shift;

            obstacle1[0]+=vitesse_obs1_x;    //dplacement des obstacles
            obstacle1[1]+=vitesse_obs1_y;
            obstacle2[0]+=vitesse_obs2_x;
            obstacle2[1]+=vitesse_obs2_y;
            obstacle3[0]+=vitesse_obs3_x;
            obstacle3[1]+=vitesse_obs3_y;
            obstacle4[0]+=vitesse_obs4_x;
            obstacle4[1]+=vitesse_obs4_y;

            if(obstacle1[0]==32 || obstacle1[0]==96-obstacle1[2])            vitesse_obs1_x=-vitesse_obs1_x;     //rebondissement des obstacles
            if(obstacle1[1]==0  || obstacle1[1]==64-obstacle1[3])            vitesse_obs1_y=-vitesse_obs1_y;
            if(obstacle2[0]==32 || obstacle2[0]==96-obstacle2[2])            vitesse_obs2_x=-vitesse_obs2_x;
            if(obstacle2[1]==0  || obstacle2[1]==64-obstacle2[3])            vitesse_obs2_y=-vitesse_obs2_y;
            if(obstacle3[0]==32 || obstacle3[0]==96-obstacle3[2])            vitesse_obs3_x=-vitesse_obs3_x;
            if(obstacle3[1]==0  || obstacle3[1]==64-obstacle3[3])            vitesse_obs3_y=-vitesse_obs3_y;
            if(obstacle4[0]==32 || obstacle4[0]==96-obstacle4[2])            vitesse_obs4_x=-vitesse_obs4_x;
            if(obstacle4[1]==0  || obstacle4[1]==64-obstacle4[3])            vitesse_obs4_y=-vitesse_obs4_y;

            afficher_obstacles(obstacle1, obstacle2, obstacle3, obstacle4);

            if(ML_pixel_test(carre_x, carre_y) || ML_pixel_test(carre_x+5, carre_y) || ML_pixel_test(carre_x+5, carre_y+5) || ML_pixel_test(carre_x, carre_y+5)) break;     //test de 'perdu ou non'

            ML_rectangle(carre_x, carre_y, carre_x+5, carre_y+5, 1, 1, 0);      //dessin du carr

            temps_actuel = RTC_getTicks();
            temps_ecoule = (int)((temps_actuel - temps_reference) / 1.28);
            cent_sec=temps_ecoule;

            if(cent_sec>=100){
                temps_reference = RTC_getTicks();       //si les centimes de sec sont  100, on remet le temps rfrence  0
                cent_sec-=100;
                sec++;                                  //et on Isz les sec ;)
            }
            if(sec>=60){
                sec-=60;
                min++;
            }

            ML_rectangle(0, 31, 26, 37, 1, 0, 0);   //efface le score de la frame prcdante
            PrintMini(5, 32, (const unsigned char *)":", 1);
            PrintMini(16, 32, (const unsigned char *)":", 1);
            PrintVariable(1, 32, min, 1);
            PrintVariable(8, 32, sec, 1);
            PrintVariable(19, 32, cent_sec, 1);        //affichage du temps de cette partie


            score=(float)(min*60+sec+cent_sec/100);          //modifie le score

            min_rec=(int)(record/60);
            record-=min_rec*60;
            sec_rec=(int)(record);
            cent_sec_rec=record-sec_rec;

            if(score*100>=recording[0] && compteur_xor<=9){ //score dpass
                compteur_xor=best_score(compteur_xor);
                if(!recording[0])   compteur_xor=10;
            }

            if(!compteur_xor || compteur_xor>9){
                PrintMini(105, 32, (const unsigned char *)":", 2);
                PrintMini(116, 32, (const unsigned char *)":", 2);
                PrintVariable(101, 32, min_rec, 2);
                PrintVariable(108, 32, sec_rec, 2);
                PrintVariable(119, 32, cent_sec_rec*100, 2);
                if(compteur_xor>=9)    ML_rectangle(101, 32, 126, 37, 1, 2, 2);
            }
            ML_display_vram();
            setFps( 4 ); // pour rguler  32 FPS
        }
        for(i=0; i<9; i++){     //explosion du carr
            ML_bmp_or_cl(Explosion[i], carre_x-6, carre_y-6, 18, 18);
            ML_display_vram();
            afficher_obstacles(obstacle1, obstacle2, obstacle3, obstacle4);
            if(ML_pixel_test(120, 1)){
                ML_rectangle(101, 32, 126, 37, 1, 1, 1);
                PrintMini(105, 32, (const unsigned char *)":", 2);
                PrintMini(116, 32, (const unsigned char *)":", 2);
                PrintVariable(101, 32, min_rec, 2);
                PrintVariable(108, 32, sec_rec, 2);
                PrintVariable(119, 32, cent_sec_rec*100, 2);
            }
            else{
                ML_rectangle(101, 32, 126, 37, 1, 0, 0);
                PrintMini(105, 32, (const unsigned char *)":", 1);
                PrintMini(116, 32, (const unsigned char *)":", 1);
                PrintVariable(101, 32, min_rec, 1);
                PrintVariable(108, 32, sec_rec, 1);
                PrintVariable(119, 32, cent_sec_rec*100, 1);
            }
            Sleep(40);
        }

        if(score*100>recording[0]){       //on sauvegarde le record
            for(i=0; i<=4; i++){
                ML_rectangle(95, 11, 135, 61, 1, 0, 0);
                afficher_obstacles(obstacle1, obstacle2, obstacle3, obstacle4);
                ML_bmp_or_cl(burst[i], 95, 11, 40, 40);
                ML_display_vram();
                Sleep(25);
            }
            recording[0]=(int) (score*100);
            ML_display_vram();
        }
        pieces=(int)(score/5);
        recording[16]+=(int)(score*100);    //ajout du temps de partie
        recording[17]+=(int)(temps_pause_partie*100);   //ainsi que du temps de pause
        recording[25]+=pieces;
        recording[26]+=pieces;
        if(carre_x<=30 || carre_x>=96 || carre_y<=1 || carre_y>=63)     recording[21]++;
        else if(!stop)  recording[22]++;
        if(pieces>=1 && !recording[1]){
            deverouillage[place]=1;
            place++;
        }
        if(pieces>=2 && !recording[2]){
            deverouillage[place]=2;
            place++;
        }
        if(pieces>=3 && !recording[3]){
            deverouillage[place]=3;
            place++;
        }

        if(!stop){          //on ne deverouille pas ce succes avec la pause ca serait trop facile ;)
            if(!recording[10] && score>=6.89 && score<=6.91){
                deverouillage[place]=10;
                place++;
            }
        }
        if(recording[16]>=360000 && !recording[9]){
            deverouillage[place]=9;
            place++;
        }
        Sleep(500);
        if(deverouillage[0])    succes(recording, deverouillage);
        memory_save(FILEPATH, recording, TAILLE);  //on sauvegarde
        place=0;
        if(stop || recording[25]>99)    break;
    }
}

void afficher_obstacles(int *obstacle1, int *obstacle2, int *obstacle3, int *obstacle4){
    //oui je sais que tant de parametre est long et inutile mais javais pas le temps de faire un grand tableau et pis cest pas bien grave : cest moi qui code ^^
    //et pis je veux TOUT mettre en local ;)
    ML_rectangle(27, 0, 99, 63, 1, 1, 0);      //affichage de la map
    ML_rectangle(28, -3, 98, 66, 3, 3, 0);
    ML_rectangle(30, 0, 96, 63, 1, 1, 0);
    ML_rectangle(obstacle1[0], obstacle1[1], obstacle1[0]+obstacle1[2], obstacle1[1]+obstacle1[3], 1, 1, 1);  //affichage des blocs
    ML_rectangle(obstacle2[0], obstacle2[1], obstacle2[0]+obstacle2[2], obstacle2[1]+obstacle2[3], 1, 1, 1);
    ML_rectangle(obstacle3[0], obstacle3[1], obstacle3[0]+obstacle3[2], obstacle3[1]+obstacle3[3], 1, 1, 1);
    ML_rectangle(obstacle4[0], obstacle4[1], obstacle4[0]+obstacle4[2], obstacle4[1]+obstacle4[3], 1, 1, 1);
}

void PrintVariable(int x, int y, int variable, int couleur){     //fonction pour afficher les temps
    char buffer[10];
    if(variable>=10 || x==1 || x==101 || x==115)    sprintf(buffer, "%d", variable);
    else    if(x!=1 && x!=101)    sprintf(buffer, "0%d", variable);
    PrintMini(x, y, (const unsigned char *)buffer, couleur);
}

int best_score(int compteur){
    ML_rectangle(100, 0, 128, 64, 1, 2, 2);
    ML_display_vram();
    Sleep(10);
    return compteur+1;
}

void transfert(int *tableau1, int *tableau2, int taille){
    int i;
    for(i=0; i<taille; i++){
        tableau1[i]=tableau2[i];
    }
}

void intro(){
    const unsigned char concours10ans[]={0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x18, 0x78, 0x0, 0x0, 0x0, 0x0, 0x3f, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x79, 0xfe, 0x0, 0x0, 0x0, 0x0, 0x7b, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xf9, 0xce, 0x0, 0x0, 0x0, 0x0, 0x7b, 0xc3, 0xc3, 0xb8, 0x7c, 0x1e, 0x1c, 0xe7, 0xa7, 0xc1, 0xf9, 0xce, 0xf, 0xc7, 0x70, 0xf8, 0x7b, 0xcf, 0xf3, 0xfc, 0xfe, 0x7f, 0x9c, 0xe7, 0xef, 0xe0, 0x79, 0xce, 0x1f, 0xe7, 0xf9, 0xfc, 0x7b, 0xce, 0x73, 0x9c, 0xee, 0x73, 0x9c, 0xe7, 0xee, 0xe0, 0x39, 0xce, 0x1d, 0xe7, 0x39, 0xdc, 0x78, 0xe, 0x73, 0x9c, 0xee, 0x73, 0x9c, 0xe7, 0x9e, 0xe0, 0x39, 0xce, 0x1c, 0xe7, 0x3b, 0xdc, 0x78, 0xe, 0x73, 0x9c, 0xee, 0x73, 0x9c, 0xe7, 0x8f, 0x0, 0x39, 0xce, 0x1c, 0xe7, 0x39, 0xe0, 0x7b, 0xce, 0x73, 0x9c, 0xe0, 0x73, 0x9c, 0xe7, 0xf, 0xc0, 0x39, 0xce, 0x3, 0xe7, 0x39, 0xf8, 0x7b, 0xce, 0x73, 0x9c, 0xe0, 0x73, 0x9c, 0xe7, 0x7, 0xe0, 0x39, 0xce, 0x1f, 0xe7, 0x38, 0xfc, 0x7b, 0xce, 0x73, 0x9c, 0xe6, 0x73, 0x9c, 0xe7, 0x1, 0xf0, 0x39, 0xce, 0x1c, 0xe7, 0x38, 0x3e, 0x7b, 0xce, 0x73, 0x9c, 0xe6, 0x73, 0x9c, 0xe7, 0xe, 0xf0, 0x39, 0xce, 0x1c, 0xe7, 0x39, 0xde, 0x7b, 0xce, 0x73, 0x9c, 0xe6, 0x73, 0x9c, 0xe7, 0xe, 0xf0, 0x39, 0xce, 0x1c, 0xe7, 0x39, 0xde, 0x3f, 0x8f, 0xf3, 0x9c, 0xfe, 0x7f, 0x9f, 0xe7, 0xf, 0xe0, 0x39, 0xfe, 0x1f, 0xe7, 0x39, 0xfc, 0x1f, 0x7, 0xc3, 0x9c, 0x7c, 0x3e, 0xe, 0xe7, 0x7, 0xc0, 0x38, 0x78, 0x1e, 0xe7, 0x38, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xc0, 0x0, 0x0, 0x1, 0xe0, 0x0, 0x0, 0x0, 0x0, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xe0, 0x0, 0x0, 0x3, 0xf0, 0x0, 0x0, 0x0, 0x1, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xe0, 0x0, 0x0, 0x3, 0xf0, 0x0, 0x0, 0x0, 0x1, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xe0, 0x0, 0x0, 0x3, 0xf0, 0x0, 0x0, 0x0, 0x1, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0xf0, 0x0, 0x0, 0x7, 0xf8, 0x0, 0x0, 0x0, 0x3, 0xfc, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0xf0, 0x0, 0x0, 0x7, 0xf8, 0x0, 0x0, 0x0, 0x3, 0xfc, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xff, 0xe0, 0x3, 0xff, 0xff, 0xf0, 0x0, 0x1, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x0, 0xf, 0xff, 0xff, 0xf0, 0x7, 0xff, 0xff, 0xf8, 0x0, 0x3, 0xff, 0xff, 0xfc, 0x0, 0x0, 0x0, 0xf, 0xff, 0xff, 0xf0, 0x7, 0xff, 0xff, 0xf8, 0x0, 0x3, 0xff, 0xff, 0xfc, 0x0, 0x0, 0x0, 0xf, 0xff, 0xff, 0xf0, 0x7, 0xff, 0xff, 0xf8, 0x0, 0x3, 0xff, 0xff, 0xfc, 0x0, 0x0, 0x0, 0x7, 0xfe, 0x7f, 0xe0, 0x3, 0xff, 0x3f, 0xf0, 0x0, 0x1, 0xff, 0x9f, 0xf8, 0x0, 0x0, 0x0, 0x3, 0xfc, 0x3f, 0xc0, 0x1, 0xfe, 0x1f, 0xe0, 0x0, 0x0, 0xff, 0xf, 0xf0, 0x0, 0x0, 0x0, 0x0, 0xfe, 0x7f, 0x0, 0x0, 0x7f, 0x3f, 0x80, 0x0, 0x0, 0x3f, 0x9f, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xfe, 0x0, 0x0, 0x3f, 0xff, 0x0, 0x0, 0x0, 0x1f, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xfe, 0x0, 0x0, 0x3f, 0xff, 0x0, 0x0, 0x0, 0x1f, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xfe, 0x0, 0x0, 0x3f, 0xff, 0x0, 0x0, 0x0, 0x1f, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0xff, 0xff, 0x0, 0x0, 0x7f, 0xff, 0x80, 0x0, 0x0, 0x3f, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, 0xff, 0xff, 0x0, 0x0, 0x7f, 0xff, 0x80, 0x0, 0x0, 0x3f, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, 0xff, 0xff, 0x0, 0x0, 0x7f, 0xff, 0x80, 0x0, 0x0, 0x3f, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, 0xfe, 0x7f, 0x0, 0x0, 0x7f, 0x3f, 0x80, 0x0, 0x0, 0x3f, 0x9f, 0xc0, 0x0, 0x0, 0x0, 0x0, 0xf8, 0x1f, 0x0, 0x0, 0x7c, 0xf, 0x80, 0x0, 0x0, 0x3e, 0x7, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x70, 0xe, 0x0, 0x0, 0x38, 0x7, 0x0, 0x0, 0x0, 0x1c, 0x3, 0x80, 0x0, 0x0, 0x0, 0x60, 0x0, 0x0, 0x18, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xf0, 0x60, 0x0, 0x0, 0x1c, 0x0, 0x0, 0x0, 0x0, 0x3e, 0x0, 0x0, 0x18, 0x0, 0x0, 0x3, 0xf8, 0x60, 0x0, 0x0, 0xe, 0x6, 0x0, 0x0, 0x0, 0x7e, 0x0, 0x0, 0x18, 0x0, 0x0, 0x3, 0x1c, 0x60, 0x0, 0x0, 0x6, 0x6, 0x0, 0x0, 0x0, 0xc6, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x4, 0x60, 0x0, 0x0, 0x0, 0x6, 0x0, 0x0, 0x1, 0x86, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x4, 0x60, 0xf1, 0x9c, 0x1f, 0x3f, 0xc7, 0xc0, 0x3, 0x0, 0x1e, 0x3, 0x98, 0x78, 0x0, 0x3, 0xc, 0x63, 0xf9, 0xbe, 0x3f, 0x3f, 0xcf, 0xc0, 0x3, 0x0, 0x7f, 0x1f, 0x98, 0xfc, 0x0, 0x3, 0x1c, 0x67, 0x19, 0xe6, 0x71, 0x86, 0x1c, 0x60, 0x6, 0x0, 0xe3, 0x38, 0x98, 0xc6, 0x0, 0x3, 0xf8, 0x66, 0x19, 0xc6, 0x63, 0x6, 0x18, 0xc0, 0x6, 0x0, 0xc3, 0x30, 0x19, 0x86, 0x0, 0x3, 0xe0, 0x64, 0x19, 0xc6, 0x4e, 0x6, 0x13, 0x87, 0xe6, 0x0, 0x83, 0x3e, 0x19, 0x86, 0x0, 0x3, 0x0, 0x64, 0x19, 0x86, 0x78, 0x6, 0x1e, 0x7, 0xe4, 0x0, 0x83, 0xf, 0x19, 0x86, 0x0, 0x3, 0x0, 0x64, 0x19, 0x86, 0x60, 0x6, 0x18, 0x0, 0x6, 0x4, 0x83, 0x1, 0x99, 0x86, 0x0, 0x3, 0x0, 0x66, 0x19, 0x86, 0x60, 0xc6, 0x18, 0x30, 0x7, 0x1c, 0xc3, 0x21, 0x99, 0x8c, 0x0, 0x3, 0x0, 0x67, 0xf9, 0x86, 0x3f, 0x86, 0xf, 0xe0, 0x3, 0xf8, 0xff, 0x7f, 0x98, 0xfc, 0x0, 0x3, 0x0, 0x63, 0xcd, 0x82, 0x1f, 0x6, 0x7, 0xc0, 0x1, 0xe0, 0x79, 0x9e, 0x18, 0x78, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
    const unsigned char darkysunprod[]={0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x7, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x7, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xf8, 0x0, 0x0, 0x0, 0x0, 0xf, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xfc, 0x0, 0x0, 0x0, 0x0, 0xf, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3f, 0xff, 0x80, 0x0, 0x0, 0x0, 0x1f, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xff, 0xff, 0xf0, 0x0, 0x0, 0x0, 0x3f, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x1, 0xff, 0xff, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xbf, 0xf8, 0x0, 0x0, 0xf, 0xff, 0xff, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x1f, 0xfe, 0xff, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xff, 0xff, 0xf0, 0x0, 0x0, 0x1f, 0xfc, 0x7f, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3f, 0xff, 0x80, 0x0, 0x0, 0x1f, 0xfe, 0xff, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xfc, 0x0, 0x0, 0x0, 0xf, 0xff, 0xff, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xf8, 0x0, 0x0, 0x0, 0x1, 0xff, 0xff, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x3f, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xf0, 0x0, 0x0, 0x0, 0x0, 0xf, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xf0, 0x4, 0x0, 0x0, 0x0, 0xf, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xf8, 0x0, 0x0, 0x0, 0xe0, 0x1c, 0x0, 0x0, 0x0, 0x7, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x1c, 0xe, 0x0, 0x0, 0x0, 0x0, 0x3c, 0x0, 0x0, 0x0, 0x7, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x30, 0x7, 0x0, 0x0, 0x0, 0x0, 0x7c, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x61, 0x83, 0x80, 0x0, 0x0, 0x0, 0x1c, 0x70, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x67, 0x1, 0xc0, 0x0, 0x0, 0x0, 0x1c, 0x78, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x43, 0x70, 0xc0, 0x0, 0x0, 0x0, 0x1c, 0x78, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x43, 0x38, 0xe1, 0xf8, 0x3, 0x1e, 0x1c, 0x18, 0x6, 0x3c, 0xf, 0xc0, 0x18, 0xf8, 0x63, 0xe0, 0x63, 0x18, 0xe3, 0xe, 0x7, 0xe7, 0x1c, 0x18, 0x1c, 0x18, 0x18, 0x60, 0x70, 0x70, 0xfe, 0x70, 0x63, 0x30, 0xe3, 0xc3, 0x1, 0xc7, 0x1c, 0x30, 0xc, 0x18, 0x33, 0x60, 0x30, 0x70, 0x78, 0x38, 0x3b, 0xf0, 0xe1, 0xc3, 0x81, 0xcf, 0x1c, 0xc0, 0x18, 0x18, 0x31, 0xe0, 0x60, 0x70, 0x30, 0x38, 0xf, 0xc0, 0xe0, 0x7f, 0x81, 0xc0, 0x1f, 0x80, 0x18, 0x18, 0x3c, 0x0, 0x60, 0x70, 0x30, 0x18, 0x3, 0x0, 0xe1, 0xc3, 0xc1, 0xc0, 0x1f, 0x0, 0x30, 0x18, 0xf, 0xc0, 0xe0, 0x70, 0x30, 0x18, 0x3, 0x1, 0xc3, 0x81, 0xc1, 0xc0, 0x1d, 0xc0, 0x30, 0x18, 0x0, 0xf0, 0xc0, 0x70, 0x30, 0x18, 0x3, 0x1, 0xc3, 0x80, 0xc1, 0xc0, 0x1c, 0xe0, 0x30, 0x18, 0x3c, 0x38, 0xc0, 0x70, 0x30, 0x18, 0x3, 0x3, 0x83, 0x0, 0xc1, 0xc0, 0x1c, 0x70, 0x30, 0x18, 0x7e, 0x38, 0xe0, 0x70, 0x30, 0x38, 0x3, 0x7, 0x3, 0x80, 0xc1, 0xc0, 0x1c, 0x38, 0x38, 0x18, 0xc6, 0x38, 0xe0, 0x70, 0x30, 0x30, 0x7, 0xe, 0x3, 0x81, 0xc1, 0xc0, 0x1c, 0x38, 0x38, 0x38, 0x4e, 0x30, 0x60, 0x70, 0x30, 0x30, 0x6, 0x78, 0x1, 0xc3, 0xe1, 0xc0, 0x1c, 0x1e, 0x1c, 0x78, 0x60, 0xe0, 0x71, 0xf8, 0x30, 0x68, 0xf, 0xc0, 0x0, 0x7e, 0xe3, 0xc0, 0x3e, 0xe, 0xf, 0xd8, 0x3f, 0x80, 0x1f, 0x18, 0x78, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0x0, 0x1c, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x3e, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x38, 0x0, 0x0, 0x7, 0xc0, 0x0, 0x0, 0x0, 0x3e, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x30, 0x0, 0x0, 0x7, 0xc0, 0x0, 0x0, 0x0, 0x3f, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xe, 0x60, 0x0, 0x0, 0x7, 0xe0, 0x0, 0x0, 0x0, 0x7f, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xc0, 0x0, 0x0, 0xf, 0xe0, 0x0, 0x0, 0x0, 0x7f, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0xe0, 0x0, 0x0, 0x0, 0xff, 0x80, 0x3e, 0x0, 0x6, 0x0, 0xc, 0xc0, 0x0, 0x0, 0x0, 0x1f, 0xf0, 0x0, 0x0, 0x1, 0xff, 0xc0, 0x36, 0xe7, 0x3e, 0xd9, 0xcc, 0xe, 0x7c, 0x0, 0x0, 0xff, 0xfe, 0x0, 0x0, 0xf, 0xff, 0xf8, 0x36, 0xed, 0xb6, 0xdb, 0x6e, 0xdb, 0x6c, 0x0, 0x7, 0xff, 0xff, 0xc0, 0x0, 0x7f, 0xff, 0xff, 0x36, 0xcd, 0xb6, 0xdb, 0x6c, 0xdb, 0x6c, 0x0, 0xf, 0xff, 0xff, 0xe0, 0x0, 0xff, 0xf7, 0xff, 0xbe, 0xcd, 0xb6, 0xdb, 0xc, 0xdb, 0x6c, 0x0, 0xf, 0xfe, 0xff, 0xe0, 0x0, 0xff, 0xe3, 0xff, 0xb0, 0xcd, 0xb6, 0xdb, 0xc, 0xdb, 0x6c, 0x0, 0xf, 0xff, 0xff, 0xe0, 0x0, 0xff, 0xf7, 0xff, 0xb0, 0xcd, 0xb6, 0xdb, 0x6c, 0xdb, 0x6c, 0x0, 0x7, 0xff, 0xff, 0xc0, 0x0, 0x7f, 0xff, 0xff, 0x30, 0xcd, 0xb6, 0xdb, 0x6c, 0xdb, 0x6c, 0x0, 0x0, 0xff, 0xfe, 0x0, 0x0, 0xf, 0xff, 0xf8, 0x30, 0xc7, 0x3e, 0xf9, 0xce, 0xce, 0x6c, 0x0, 0x0, 0x1f, 0xf0, 0x0, 0x0, 0x1, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0xe0, 0x0, 0x0, 0x0, 0xff, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0xe0, 0x0, 0x0, 0x0, 0x7f, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xe0, 0x0, 0x0, 0x0, 0x7f, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xc0, 0x0, 0x0, 0x0, 0x3f, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xc0, 0x0, 0x0, 0x0, 0x3e, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x3e, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1c, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
    const unsigned char escapethedeath[]={0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3f, 0xff, 0xc0, 0x1f, 0xe0, 0x0, 0x3f, 0xe0, 0x0, 0x30, 0x0, 0x7f, 0xff, 0x7, 0xff, 0xf8, 0xf, 0xff, 0xc0, 0x7f, 0xf0, 0x1, 0xff, 0xf0, 0x0, 0x38, 0x0, 0xf, 0xff, 0xc1, 0xff, 0xf8, 0x7, 0x80, 0xc0, 0xf0, 0x78, 0x3, 0xe0, 0x78, 0x0, 0x78, 0x0, 0xf, 0x7, 0xe0, 0xf0, 0x18, 0x7, 0x80, 0xc1, 0xe0, 0x18, 0xf, 0x80, 0x18, 0x0, 0x7c, 0x0, 0xf, 0x3, 0xe0, 0xf0, 0x18, 0x7, 0x80, 0xc1, 0xc0, 0x10, 0xf, 0x0, 0x0, 0x0, 0xfc, 0x0, 0xf, 0x3, 0xe0, 0xf0, 0x18, 0x7, 0x80, 0x3, 0xc0, 0x0, 0x1e, 0x0, 0x0, 0x0, 0xfe, 0x0, 0xf, 0x1, 0xe0, 0xf0, 0x0, 0x7, 0x80, 0x3, 0xc0, 0x0, 0x3e, 0x0, 0x0, 0x0, 0xbe, 0x0, 0xf, 0x1, 0xe0, 0xf0, 0x0, 0x7, 0x81, 0x3, 0xe0, 0x0, 0x3e, 0x0, 0x0, 0x1, 0x9e, 0x0, 0xf, 0x3, 0xe0, 0xf0, 0x20, 0x7, 0x81, 0x3, 0xf8, 0x0, 0x3c, 0x0, 0x0, 0x1, 0x9f, 0x0, 0xf, 0x3, 0xc0, 0xf0, 0x20, 0x7, 0xff, 0x1, 0xff, 0x0, 0x3c, 0x0, 0x0, 0x3, 0xf, 0x0, 0xf, 0x7, 0x80, 0xff, 0xe0, 0x7, 0xff, 0x0, 0xff, 0xf0, 0x3c, 0x0, 0x0, 0x3, 0xf, 0x80, 0xf, 0x7f, 0x0, 0xff, 0xe0, 0x7, 0x81, 0x0, 0x7f, 0xf8, 0x3c, 0x0, 0x0, 0x2, 0xf, 0x80, 0xf, 0x3e, 0x0, 0xf0, 0x20, 0x7, 0x81, 0x0, 0xf, 0xfc, 0x3c, 0x0, 0x0, 0x6, 0x7, 0xc0, 0xf, 0x0, 0x0, 0xf0, 0x20, 0x7, 0x80, 0x0, 0x1, 0xfc, 0x3e, 0x0, 0x0, 0x7, 0xff, 0xc0, 0xf, 0x0, 0x0, 0xf0, 0x0, 0x7, 0x80, 0x0, 0x0, 0x7c, 0x3e, 0x0, 0x0, 0xf, 0xff, 0xc0, 0xf, 0x0, 0x0, 0xf0, 0x0, 0x7, 0x80, 0x2, 0x0, 0x3c, 0x1e, 0x0, 0x0, 0xc, 0x3, 0xe0, 0xf, 0x0, 0x0, 0xf0, 0x0, 0x7, 0x80, 0x2, 0x0, 0x3c, 0x1f, 0x0, 0x0, 0xc, 0x3, 0xe0, 0xf, 0x0, 0x0, 0xf0, 0x0, 0x7, 0x80, 0xc3, 0x0, 0x3c, 0xf, 0x80, 0x0, 0x18, 0x1, 0xf0, 0xf, 0x0, 0x0, 0xf0, 0x18, 0x7, 0x80, 0xc3, 0x0, 0x38, 0xf, 0xc0, 0x4, 0x18, 0x1, 0xf0, 0xf, 0x0, 0x0, 0xf0, 0x18, 0x7, 0x80, 0xc3, 0xc0, 0xf0, 0x7, 0xf0, 0x18, 0x38, 0x0, 0xf8, 0xf, 0x0, 0x0, 0xff, 0xf8, 0x7, 0xff, 0xc1, 0xff, 0xe0, 0x1, 0xff, 0xf0, 0x30, 0x0, 0xf8, 0xf, 0x80, 0x3, 0xff, 0xf8, 0x1f, 0xff, 0xc0, 0xff, 0x80, 0x0, 0x3f, 0xc0, 0xfe, 0x7, 0xfe, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x31, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x31, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7d, 0xb8, 0x78, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x31, 0xcc, 0xcc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x31, 0x8c, 0xcc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x31, 0x8c, 0xfc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x31, 0x8c, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x31, 0x8c, 0xcc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3d, 0xdc, 0x78, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x80, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x0, 0x3, 0xe0, 0x3, 0xfe, 0x7, 0xfe, 0x3, 0x81, 0xff, 0xcf, 0x8f, 0x80, 0xf, 0x80, 0x0, 0x0, 0x3, 0xf8, 0x1, 0xc7, 0x83, 0x86, 0x3, 0x81, 0x9c, 0xc7, 0x7, 0x0, 0x3f, 0x80, 0x0, 0x7f, 0xff, 0xfc, 0x1, 0xc1, 0xc3, 0x86, 0x7, 0x81, 0x1c, 0x47, 0x7, 0x0, 0x7f, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0x1, 0xc1, 0xc3, 0x80, 0x5, 0xc1, 0x1c, 0x47, 0x7, 0x1, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xc1, 0xc1, 0xe3, 0x80, 0xd, 0xc0, 0x1c, 0x7, 0x7, 0x7, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xf1, 0xc0, 0xe3, 0x88, 0x9, 0xc0, 0x1c, 0x7, 0x7, 0x1f, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xf9, 0xc0, 0xe3, 0xf8, 0x8, 0xe0, 0x1c, 0x7, 0xff, 0x3f, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xf1, 0xc0, 0xe3, 0x88, 0x18, 0xe0, 0x1c, 0x7, 0x7, 0x1f, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xc1, 0xc0, 0xe3, 0x80, 0x10, 0xe0, 0x1c, 0x7, 0x7, 0x7, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0x1, 0xc1, 0xc3, 0x80, 0x3f, 0xf0, 0x1c, 0x7, 0x7, 0x1, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xfc, 0x1, 0xc1, 0xc3, 0x86, 0x30, 0x70, 0x1c, 0x7, 0x7, 0x0, 0x7f, 0xff, 0xfc, 0x0, 0x3, 0xf8, 0x1, 0xc1, 0x83, 0x86, 0x20, 0x70, 0x1c, 0x7, 0x7, 0x0, 0x3f, 0x80, 0x0, 0x0, 0x3, 0xe0, 0x1, 0xc3, 0x3, 0x86, 0x60, 0x78, 0x1c, 0x7, 0x7, 0x0, 0xf, 0x80, 0x0, 0x0, 0x3, 0x80, 0x3, 0xfe, 0x7, 0xfe, 0xf0, 0xfc, 0x3e, 0xf, 0x8f, 0x80, 0x3, 0x80, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
    int x, y, i;
    srand(RTC_getTicks());

    for(i=0; i<=15; i++){
        ML_clear_vram();
        x=rand()%10;
        y=rand()%10;
        ML_bmp_or_cl(darkysunprod, x-5, y-5, 128, 64);          //on affiche l'cran
        ML_display_vram();
        Sleep(15);
    }
    ML_clear_vram();
    ML_bmp_or(darkysunprod, 0, 0, 128, 64);
    ML_display_vram();
    Sleep(1500);

    transition(1);

    ML_clear_vram();
    Txt_Text("Presente", 40, 28, TXT_SERIF, TXT_OR);
    ML_display_vram();
    Sleep(2000);

    for(i=0; i<=15; i++){
        ML_clear_vram();
        x=rand()%10;
        y=rand()%10;
        ML_bmp_or_cl(escapethedeath, x-5, y-5, 128, 64);          //on affiche l'cran
        ML_display_vram();
        Sleep(15);
    }
    ML_clear_vram();
    ML_bmp_or(escapethedeath, 0, 0, 128, 64);
    ML_display_vram();
    Sleep(1500);

    transition(2);

    ML_clear_vram();
    Txt_Text("A l'occasion du", 13, 28, TXT_SERIF, TXT_OR);
    ML_display_vram();
    Sleep(2000);

    for(i=0; i<=15; i++){
        ML_clear_vram();
        x=rand()%10;
        y=rand()%10;
        ML_bmp_or_cl(concours10ans, x-5, y-5, 128, 64);          //on affiche l'cran
        ML_display_vram();
        Sleep(15);
    }
    ML_clear_vram();
    ML_bmp_or(concours10ans, 0, 0, 128, 64);
    ML_display_vram();
    Sleep(2000);
}

void transition(int a){
    int i;
    for(i=0; i<128; i++){
        ML_line(0, i, 128, i, 1);
        ML_line(0, i-64, 128, i-64, 0);
        if(a==1 && i>80)        Txt_Text("Presente", 40, 28, TXT_SERIF, TXT_OR);
        if(a==2 && i>80)        Txt_Text("A l'occasion du", 13, 28, TXT_SERIF, TXT_OR);
        if(a==3 && i>80)        Txt_Text("Retrouvez moi sur", 6, 28, TXT_SERIF, TXT_OR);
        ML_display_vram();
        Sleep(20);
    }
}

void direction(int *tableau, int vit_x, int vit_y, int color){
    int coin;   //fonction pour tracer des fleches au coin de chaque quadrilatere suivant leur direction
    /*-2   0

       1   2
    */
    coin=vit_x+vit_y;
    if(!coin){
        if(vit_x>0) coin=0;
        else coin++;
    }
    if(coin==-2){
        ML_line(tableau[0], tableau[1], tableau[0]-3, tableau[1]-3, color);
        ML_line(tableau[0]-3, tableau[1]-3, tableau[0]-3, tableau[1], color);
        ML_line(tableau[0]-3, tableau[1]-3, tableau[0], tableau[1]-3, color);
    }
    if(!coin){
        ML_line(tableau[0]+tableau[2], tableau[1], tableau[0]+tableau[2]+3, tableau[1]-3, color);
        ML_line(tableau[0]+tableau[2]+3, tableau[1]-3, tableau[0]+tableau[2]+3, tableau[1], color);
        ML_line(tableau[0]+tableau[2]+3, tableau[1]-3, tableau[0]+tableau[2], tableau[1]-3, color);
    }
    if(coin==1){
        ML_line(tableau[0], tableau[1]+tableau[3], tableau[0]-3, tableau[1]+tableau[3]+3, color);
        ML_line(tableau[0]-3, tableau[1]+tableau[3]+3, tableau[0]-3, tableau[1]+tableau[3], color);
        ML_line(tableau[0]-3, tableau[1]+tableau[3]+3, tableau[0], tableau[1]+tableau[3]+3, color);
    }
    if(coin==2){
        ML_line(tableau[0]+tableau[2], tableau[1]+tableau[3], tableau[0]+tableau[2]+3, tableau[1]+tableau[3]+3, color);
        ML_line(tableau[0]+tableau[2]+3, tableau[1]+tableau[3]+3, tableau[0]+tableau[2]+3, tableau[1]+tableau[3], color);
        ML_line(tableau[0]+tableau[2]+3, tableau[1]+tableau[3]+3, tableau[0]+tableau[2], tableau[1]+tableau[3]+3, color);
    }

}



//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section
